﻿--- ------------------------------------------------
---            << Power Auras >>
---              Par -Sinsthar-
---    [Ziya/Tiven - serveur Fr - Kirin Tor] 
---
---     Effets visuels autour du personnage 
---     en cas de buff, debuff et autres...
--- ------------------------------------------------

--- Author: Driizt (v2.5+), Garstiger (Powa Continued), Sinsthar (original author/concept) 
--- Changes:
--- Version 2.6.0 (WotLK)
---  Feature: WoW 3.1 compatibility update.
---  Feature: Deathknight Presences added to Stance Auras.
---  Feature: Whitespace added to export strings to facilitate forum posting.
---  Feature: Better granularity for Mana/Health/Rage/Energy/Power threshold (step 5 -> 2).
---  Feature: Mounted option changed to toggle (checked: only when mounted, unchecked: only when dismounted)
---  Feature: Texture glow option affects timer.
---  Bugfix: Mana/Rage/Energy/RunicPower Party & Raid triggers.
---  Bugfix: Mana/Rage/Energy/RunicPower Unit triggers.
---  Bugfix: PvP Trigger.
---  Bugfix: "Casted" -> "Cast" typo.
--- Version 2.5.9a (WotLK)
---  Bugfix: 'hundredth', 'dual' timers checkbox errors.
--- Version 2.5.9 (WotLK)
---  Feature: Option to monitor "my" buffs/debuffs.
---  Feature: Unlimited timers. (1 per aura instead of 5 total)
---  Feature: Dynamic Aura update when multiple matches and 'own texture' checked.
---  Feature: Import and export Auras as strings.
---  Feature: Any/All toggle for party, raid buff checks. (default = all)
---  Bugfix: Action Usable aura when action linked to stance.
---  Bugfix: Make "Activate Power Auras" checkbox actually do something and shutdown processing when unchecked. :P
--- Version 2.5.8b (WotLK)
---  Bugfix: gui bug threshold invert option.
--- Version 2.5.8a (WotLK)
---  Bugfix: combination triggers with "show when not active" checked.
---  Various internal logic optimizations.
--- Version 2.5.8 (WotLK)
---  Bugfix: Various label fonts (template breakage by Blizzard in builds 8982->9014)
---  Bugfix: Font Select button not visible on first editor open.
---  Feature: Text shadow option for textauras.
---  Feature: Ability to setup auras with combination of triggers.
---  Feature: Spell Casting activation trigger added (target and focus).
--- Version 2.5.7b (WotLK)
---  Bugfix: Begin animation "replaying" on aura refresh.
--- Version 2.5.7a (WotLK)
---  Bugfix: Offhand temporary enchant detection/stacks
---	 Feature: Weapon buff auras can be defined separately per temporary enchant 
---           and optionally filtered by slot (main or offhand)
--- Version 2.5.7 (WotLK)
---  Feature: Text Aura Option added (thanks to Garstiger for initial code)
---  Feature: Option to invert default threshold behavior added.
---  Feature: Pet health/mana activation enabled (enter "pet" in UnitName editbox)
---  Bugfix: Manual.html pictures (submitted by Garstiger)
---  Bugfix: Aura Type checkboxes
---  Bugfix: UnitName nil error
---  Bugfix: Threshold when Rage/Energy/Power is zero.
--- Version 2.5.6c (WotLK)
---  Bugfix: Not in Combat initial state.
--- Version 2.5.6b (WotLK)
---  Bugfix: Timer checkboxes nil error
---  Bugfix: Target buff/debuff timers
--- Version 2.5.6a (WotLK)
---  Bugfix: GetComboPoints() API change.
--- Version 2.5.6 (WotLK)
---  Feature: Runic Power threshold added.
---  Bugfix: GetPlayerBuff/UnitBuff/Debuff API changes.
---  Bugfix: UIDropMenu, PanelTemplates_TabResize, Font Widget, this->self changes. 
--- Version 2.5.5b
---  Bugfix: Health/Mana threshold for party/raid units (line 1297 error)
--- Version 2.5.5a
---  Bugfix: Custom duration timer for target buffs/debuffs (wasn't reseting on target change)
---  Bugfix: Hide player auras when dead/ghost.
--- Version 2.5.5
---  Feature: Stance options for Druid and Rogue(stealth) added
---  Bugfix: Stance detection is now dynamic so lower levels that don't have all forms/stances yet are supported.
---  Feature: Custom timer enabled for action usable. It overrides the calculated timers if used.
---  Feature: Rage/Energy trigger implemented with upper thresholds.
--- Version 2.5.4a
---  Bugfix: Buff and Debuff timers for non-player units.
--- Version 2.5.4
---  Bugfix: Buff and Debuff timers.
---  Feature: Custom textures editbox now accepts spellname or spellid in addition to filename.tga
--- Version 2.5.3
---  Bugfix: Buff and Debuff stacks.
---  Bugfix: Mana-threshold auras when shifting to bear/cat.
---  Feature: New custom sounds.
---  Feature: Updated zh-CN localization by <Doomiris>.
--- Version 2.5.2
---  Feature: 30 more wow textures added to available choices
---  Feature: PvP flag added to triggers
---  Feature: Aggro status added to triggers
---  Feature: Option to use ability/spell texture instead of predetermined choice where available.
--- Version 2.5.1a
---  Feature: Hide Auras when hiding the interface (Alt+z)
--- Version 2.5.1
---  Feature: WoW 2.4 compatibility re-code (various changes related to the new combatlog)
---  Feature: New textures can now be added to defaults as long as they're named Auraxx.tga
---           The selection slider will accommodate automatically next time you start the game.
---  Bugfix: Stance detection
---  Bugfix: Mounted detection (flying included)
---  Bugfix: Aura change
---  Bugfix: Action Usable (workaround for the absense of cooldown complete events)
---          If you want to get notification when a trinket or bag item is usable you have
---					 drag it to an actionbar (doesn't have to be a visible one)	 

PowaVersion = "v2.6.0"

CurrentAura = 1;
CurrentSecondeAura = 0;
MaxAuras = 360;
SecondeAura = 0;
CurrentTestAura = 361;

PowaEnabled = 0;
PowaModTest = false; --- on test les effets

Powa_FramesVisibleTime = {}; --- visible ou pas

Powa_banzai = LibStub("LibBanzai-2.0", true)

PowaMisc = {
	disabled = false,
	debug = false,
	playerclass = false,
	maxeffects = 100,

	BTimerX = 0,
	BTimerY = 0,
	BTimerA = 1.00,
	BTimerScale = 1.00,
	BCents = true,
	Bdual = false,
};

Powa_Events = {}
Powa_Events[1] = "PLAYER_ENTERING_WORLD";
Powa_Events[2] = "PLAYER_TARGET_CHANGED";
Powa_Events[3] = "PLAYER_FOCUS_CHANGED";
Powa_Events[4] = "PLAYER_AURAS_CHANGED";
Powa_Events[5] = "PLAYER_REGEN_DISABLED";
Powa_Events[6] = "PLAYER_REGEN_ENABLED";
Powa_Events[7] = "PLAYER_DEAD";
Powa_Events[8] = "PLAYER_ALIVE";
Powa_Events[9] = "PLAYER_UNGHOST";
Powa_Events[10] = "PLAYER_UPDATE_RESTING";
Powa_Events[11] = "UNIT_HEALTH";
Powa_Events[12] = "UNIT_MAXHEALTH";
Powa_Events[13] = "UNIT_MANA";
Powa_Events[14] = "UNIT_MAXMANA";
Powa_Events[15] = "UNIT_RAGE";
Powa_Events[16] = "UNIT_ENERGY";
Powa_Events[17] = "UNIT_MAXENERGY";
Powa_Events[18] = "UNIT_COMBO_POINTS";
Powa_Events[19] = "UNIT_RUNIC_POWER";
Powa_Events[20] = "UNIT_MAXRUNIC_POWER";
Powa_Events[21] = "UNIT_AURA";
Powa_Events[22] = "UNIT_AURASTATE";
Powa_Events[23] = "UNIT_FACTION";
Powa_Events[24] = "UNIT_ENTERED_VEHICLE"; --- implementation pending
Powa_Events[25] = "UNIT_EXITED_VEHICLE"; --- implementation pending
Powa_Events[26] = "UNIT_SPELLCAST_START";
Powa_Events[27] = "UNIT_SPELLCAST_STOP";
Powa_Events[28] = "UNIT_SPELLCAST_FAILED";
Powa_Events[29] = "UNIT_SPELLCAST_INTERRUPTED";
Powa_Events[30] = "UNIT_SPELLCAST_DELAYED";
Powa_Events[31] = "UNIT_SPELLCAST_CHANNEL_START";
Powa_Events[32] = "UNIT_SPELLCAST_CHANNEL_UPDATE";
Powa_Events[33] = "UNIT_SPELLCAST_CHANNEL_STOP";
Powa_Events[34] = "UNIT_SPELLCAST_SUCCEEDED";
Powa_Events[35] = "PARTY_MEMBERS_CHANGED";
Powa_Events[36] = "RAID_ROSTER_UPDATE";
Powa_Events[37] = "COMBAT_LOG_EVENT_UNFILTERED";
Powa_Events[38] = "UPDATE_SHAPESHIFT_FORM";
Powa_Events[39] = "ACTIONBAR_UPDATE_USABLE";
Powa_Events[40] = "ACTIONBAR_UPDATE_COOLDOWN";
Powa_Events[41] = "ACTIONBAR_SLOT_CHANGED";
Powa_Events[42] = "UPDATE_SHAPESHIFT_FORMS";
Powa_Events[43] = "VARIABLES_LOADED";

PowaTimer = {};

PowaGlobal = {}; --- {maxtextures = 50}

PowaSet = {};
for i = 0, 1 do
	PowaSet[i] = { --- ici
		off = false,
		texmode = 1,
		wowtex = false,
		customtex = false,
		textaura = false,
		owntex = false,
		realaura = 1,
		texture = 1,
		customname = "",
		aurastext = "",
		aurastextfont = 1,
		icon = "",
		timer = false,
		timerduration = 0,	
		sound = 0,
		soundfile = "",
		customsound = "",			
		anim1 = 1,
		anim2 = 0,
		speed = 1.00,
		begin = 0,
		finish = 1,
		duration = 0,
		alpha = 0.75,
		size = 0.75,
		torsion = 1,
		symetrie = 0,
		x = 0,
		y = -30,
		randomcolor = false,
		r = 1.0,
		g = 1.0,
		b = 1.0,
		opt1 = 0,
		opt2 = 0,
		inverse = false,
		buffname = "",
		ignoremaj = true,
		exact = false,
		bufftype = 1,		
		isdebuff = false,
		isdebufftype = false,
		isenchant = false,
		stacks = 0,
		stacksOperator = "=",
		threshold = 50,
		thresholdinvert = false,
		mine = false,
		focus = false,
		target = false,
		targetfriend = false,	
		raid = false,
    party = false,
    groupany = false,
    optunitn = false,
    unitn = "",
    isinraid = false,
    ismounted = false,
    combat = 0, 
		gcd = false,
		stance = 10,
		multiids = "",
	};
end

--- checks des buffs
DoCheckBuffs = false;
DoCheckTargetBuffs = false;
DoCheckPartyBuffs = false;
DoCheckRaidBuffs = false;
DoCheckUnitBuffs = false;
DoCheckFocusBuffs = false;

DoCheckHealth = false;
DoCheckTargetHealth = false;
DoCheckPartyHealth = false;
DoCheckRaidHealth = false;
DoCheckFocusHealth = false;
DoCheckUnitHealth = false;

DoCheckMana = false;
DoCheckTargetMana = false;
DoCheckPartyMana = false;
DoCheckRaidMana = false;
DoCheckFocusMana = false;
DoCheckUnitMana = false;

DoCheckRageEnergy = false;
DoCheckTargetRageEnergy = false;
DoCheckPartyRageEnergy = false;
DoCheckRaidRageEnergy = false;
DoCheckFocusRageEnergy = false;
DoCheckUnitRageEnergy = false;

DoCheckOthers = false;
DoCheckCombo = false;
DoCheckAoe = false;
DoResetAoe = false;

DoCheckStance = false;
DoCheckAction = false;
DoCheckEnchant = false;

DoCheckMounted = false;

DoCheckPvP = false; -- added
DoCheckPartyPvP = false; -- added
DoCheckRaidPvP = false; -- added
DoCheckTargetPvP = false; -- added

DoCheckAggro = false; -- added
DoCheckPartyAggro = false; -- added
DoCheckRaidAggro = false; -- added

DoCheckSpells = false;
DoCheckTargetSpells = false;
DoCheckFocusSpells = false;

ResetTargetTimers = false;

--- liste des effets dans l'editeur par type
ListBuffs = {};
ListBuffsMax = 0;
ListTargetBuffs = {};
ListTargetBuffsMax = 0;
ListPartyBuffs = {};
ListPartyBuffsMax = 0;
ListRaidBuffs = {};
ListRaidBuffsMax = 0;
ListUnitBuffs = {};
ListUnitBuffsMax = 0;
ListFocusBuffs = {};
ListFocusBuffsMax = 0;

ListEnchants = {};
ListEnchantsMax = 0;

ListCombo = {};
ListComboMax = 0;

ListAoe = {};
ListAoeMax = 0;

ListActions = {};
ListActionsMax = 0;

ListHealth = {};
ListHealthMax = 0;
ListTargetHealth = {};
ListTargetHealthMax = 0;
ListFocusHealth = {};
ListFocusHealthMax = 0;
ListPartyHealth = {};
ListPartyHealthMax = 0;
ListRaidHealth = {};
ListRaidHealthMax = 0;
ListUnitHealth = {};
ListUnitHealthMax = 0;

ListMana = {};
ListManaMax = 0;
ListTargetMana = {};
ListTargetManaMax = 0;
ListFocusMana = {};
ListFocusManaMax = 0;
ListPartyMana = {};
ListPartyManaMax = 0;
ListRaidMana = {};
ListRaidManaMax = 0;
ListUnitMana = {};
ListUnitManaMax = 0;

ListRageEnergy = {};
ListRageEnergyMax = 0;
ListTargetRageEnergy = {};
ListTargetRageEnergyMax = 0;
ListPartyRageEnergy = {};
ListPartyRageEnergyMax = 0;
ListRaidRageEnergy = {};
ListRaidRageEnergyMax = 0;
ListFocusRageEnergy = {};
ListFocusRageEnergyMax = 0;
ListUnitRageEnergy = {};
ListUnitRageEnergyMax = 0;

ListPvP = {};
ListPvPMax = 0;
ListPartyPvP = {};
ListPartyPvPMax = 0;
ListRaidPvP = {};
ListRaidPvPMax = 0;
ListTargetPvP = {};
ListTargetPvPMax = 0;

ListAggro = {};
ListAggroMax = 0;
ListPartyAggro = {};
ListPartyAggroMax = 0;
ListRaidAggro = {};
ListRaidAggroMax = 0;

ListStance = {};
ListStanceMax = 0;

ListSpells = {};
ListSpellsMax = 0;
ListTargetSpells = {};
ListTargetSpellsMax = 0;
ListFocusSpells = {};
ListFocusSpellsMax = 0;

WeAreInCombat = false;
WeAreInRaid = false;
WeAreMounted = false;
WeAreInVehicle = false;
WeAreAlive = true;
AuraHide = false;

AoeAuraAdded = "";
AoeAuraFaded = "";

ChecksTimer = 0;  --- [mode lourd]
NextCheck = 0.2; --- [mode lourd] nombre de secondes entre les checks
UsablePending = {}; --- Driizt workaround for 'silent' cooldown end (no event fired)
AggroStatus = {};

PowaStance = {};
PowaStance[0] = "-------------";

DebugTimer = 0;

local isULDUAR = select(4, _G.GetBuildInfo()) >= 30100;

--- ---------------------------------------------------------------------------------------------------------

function Powa_OnLoad(self)
	
	Powa_Frames = {};
	Powa_textures = {};
	
	--- Setting up the Import/Export static popups
	Powa_StaticPopups();

	--- Setting up the Aggro Lib callback ---
	if Powa_banzai then
		Powa_banzai:RegisterCallback(Powa_banzaiCallback);
	end
	
	--- TODO: conditionally Register/unregister events according to options for improved performance
	for i, evt in ipairs(Powa_Events) do
		self:RegisterEvent(evt);
	end
	
	--- options init
	SlashCmdList["POWA"] = Powa_ShowMainOptions;
	SLASH_POWA1 = "/powa";
  	
end

function PowaToggle(enabled)
	if enabled then
		if Powa_Frame and not Powa_Frame:IsShown() then
			if Powa_banzai then
				Powa_banzai:RegisterCallback(Powa_banzaiCallback);
			end
			Powa_Frame:Show();
			for i,evt in ipairs(Powa_Events) do
				Powa_Frame:RegisterEvent(evt);
			end
		end
		PowaMisc.disabled = false;
	else
		if Powa_Frame and Powa_Frame:IsShown() then
			if Powa_banzai and Powa_banzai:IsRunning() then
				Powa_banzai:UnregisterCallback(Powa_banzaiCallback);
			end
			Powa_Frame:UnregisterAllEvents();
			Powa_Frame:Hide();
		end
		Powa_OptionHideAll(true);
		PowaMisc.disabled = true;
	end
end

function PowaDebug(msg)
	if (PowaMisc.debug == true) then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end

function PowaDebug2(msg)
	getglobal("PowaDebugMessagesText"):SetText(msg);
end

--- ---------------------------------------------------------------------------------------------------- EVENT
--- sets flags to toggle checks in OnUpdate cycles
function Powa_OnEvent(self, event, ...)  
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, 
		arg9, arg10, arg11,	arg12, arg13, arg14, arg15, arg16, 
		arg17, arg18, arg19 = ...;

	if event == "VARIABLES_LOADED" then
		DEFAULT_CHAT_FRAME:AddMessage("|cffB0A0ff<Power Auras Classic>|r |cffffff00"..PowaVersion.."|r - "..PowaText.welcome);
		_, PowaMisc.playerclass = UnitClass("player");
		Powa_InitTabs(); --- verifie en cas de rajout d'effets que tous sont initialises (sinon ca bug :P)
		Powa_LoadGlobalStats();
		Powa_CreateFrames(0); --- cree la frame 0 (secondaire)
	
		PowaGlobal.maxtextures = 1;
		local texi = 1;
		while ( getglobal("AuraTexture"):SetTexture("Interface\\Addons\\PowerAuras\\Auras\\Aura"..texi..".tga") == 1 ) do 
			PowaGlobal.maxtextures = texi;
			texi = texi+1;
		end
		
		getglobal("PowaBarAuraTextureSlider"):SetMinMaxValues(1, PowaGlobal.maxtextures);
		getglobal("PowaBarAuraTextureSliderHigh"):SetText(PowaGlobal.maxtextures);
		
		PowaEnabled = 1;
		Powa_CreateEffectLists();	
	
	elseif event == "PLAYER_ENTERING_WORLD" then
		if (PowaMisc.disabled == true) then
			PowaToggle(false);
			return;
		end
		Powa_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");

	  DoCheckBuffs = true;
	  DoCheckOthers = true;
	  DoCheckCombo = true;
		DoCheckTargetBuffs  = true;
		DoCheckPartyBuffs  = true;
		DoCheckRaidBuffs  = true;
		DoCheckUnitBuffs  = true;
		DoCheckFocusBuffs  = true;
		DoCheckHealth = true;
		DoCheckTargetHealth = true;
		DoCheckPartyHealth  = true;
		DoCheckRaidHealth  = true;
		DoCheckFocusHealth  = true;
		DoCheckMana = true;
		DoCheckTargetMana = true;
		DoCheckPartyMana  = true;
		DoCheckRaidMana  = true;
		DoCheckFocusMana = true;
		DoCheckRageEnergy = true;
		DoCheckTargetRageEnergy = true;
		DoCheckPartyRageEnergy  = true;
		DoCheckRaidRageEnergy  = true;
		DoCheckFocusRageEnergy = true;
		DoCheckStance = true;
		DoCheckAction = true;
		DoCheckEnchant = true;
		DoCheckMounted = true;
		DoCheckPvP = true;
		DoCheckPartyPvP = true;
		DoCheckRaidPvP = true;
		DoCheckTargetPvP = true;
		DoCheckAggro = true;
		DoCheckPartyAggro = true;
		DoCheckRaidAggro = true;
		DoCheckSpells = true;
		DoCheckTargetSpells = true;
		DoCheckFocusSpells = true;
		if UnitIsDeadOrGhost("player") then
			WeAreAlive = false;
		end
		if (GetNumRaidMembers() > 0) then
			WeAreInRaid = true;
		else
			WeAreInRaid = false;
		end
		if IsMounted() or IsFlying() then
			WeAreMounted = true;
		else
			WeAreMounted = false;
		end
		if UnitHasVehicleUI("player") and UnitIsUnit("vehicle", "pet") then
			WeAreInVehicle = true;
		else
			WeAreInVehicle = false;
		end
		
		if PowaMisc.playerclass and (PowaMisc.playerclass == "WARRIOR" 
		or PowaMisc.playerclass == "DRUID" 
		or PowaMisc.playerclass == "ROGUE" 
		or PowaMisc.playerclass == "DEATHKNIGHT") then
			local numforms = GetNumShapeshiftForms();
			if numforms > 0 then
				for i=1, numforms do
					PowaStance[i] = select(2,GetShapeshiftFormInfo(i));
				end
			end
		end
		
		Powa_MemorizeActions(0);
		
	elseif event == "PARTY_MEMBERS_CHANGED" then	  
		DoCheckPartyBuffs = true;
		DoCheckPartyHealth = true;
		DoCheckPartyMana = true;
		
	elseif event == "RAID_ROSTER_UPDATE" then	  
		DoCheckRaidBuffs = true;
		DoCheckRaidHealth = true;
		DoCheckRaidMana = true;	
		if GetNumRaidMembers() > 0 then
			WeAreInRaid = true;
		else
			WeAreInRaid = false;
		end
				
	elseif event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" then
		if (PowaModTest == false) then
			if (arg1 == "target") then
				DoCheckTargetHealth = true;				
      elseif (arg1 == "focus") then             
		    DoCheckFocusHealth = true;				
			elseif ("party" == string.sub(arg1, 1, 5)) then 
		    DoCheckPartyHealth = true;  	
		    DoCheckUnitHealth = true;			
			elseif ("raid" == string.sub(arg1, 1, 4)) then              
		    DoCheckRaidHealth = true;		
		    DoCheckUnitHealth = true;		
		  elseif (arg1 == "pet") then
		  	DoCheckUnitHealth = true;
	    elseif (arg1 == "player") then
				DoCheckHealth = true; --- active les checks		
	    end
	  end
		
	elseif event == "UNIT_MANA" or event == "UNIT_MAXMANA" then
		if (PowaModTest == false) then
			if (arg1 == "target") then
				DoCheckTargetMana = true;				
      elseif (arg1 == "focus") then             
		    DoCheckFocusMana = true;				
			elseif ("party" == string.sub(arg1, 1, 5)) then
		    DoCheckPartyMana = true;  	
		    DoCheckUnitMana = true;			
			elseif ("raid" == string.sub(arg1, 1, 4)) then
		    DoCheckRaidMana = true;
		    DoCheckUnitMana = true;
		  elseif (arg1 == "pet") then
		  	DoCheckUnitMana = true;				
	    elseif (arg1 == "player") then
			  DoCheckMana = true; --- active les checks		
	    end
	 	end	
	
	elseif event == "UNIT_RAGE" then
		if (PowaModTest == false) then
			if (arg1 == "target") then
				DoCheckTargetRageEnergy = true;
			elseif (arg1 == "focus") then
				DoCheckFocusRageEnergy = true;
			elseif ("party" == string.sub(arg1, 1, 5)) then
				DoCheckPartyRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif ("raid" == string.sub(arg1, 1, 4)) then
				DoCheckRaidRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "pet") then
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "player") then
				DoCheckRageEnergy = true;
			end		
		end
	
	elseif event == "UNIT_ENERGY" or event == "UNIT_MAXENERGY" then
		if (PowaModTest == false) then
			if (arg1 == "target") then
				DoCheckTargetRageEnergy = true;
			elseif (arg1 == "focus") then
				DoCheckFocusRageEnergy = true;
			elseif ("party" == string.sub(arg1, 1, 5)) then 
				DoCheckPartyRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif ("raid" == string.sub(arg1, 1, 4)) then
				DoCheckRaidRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "pet") then
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "player") then
				DoCheckRageEnergy = true;
			end		
		end
	
	elseif event == "UNIT_RUNIC_POWER" or event == "UNIT_MAXRUNIC_POWER" then
		if (PowaModTest == false) then
			if (arg1 == "target") then
				DoCheckTargetRageEnergy = true;
			elseif (arg1 == "focus") then
				DoCheckFocusRageEnergy = true;
			elseif ("party" == string.sub(arg1, 1, 5)) then 
				DoCheckPartyRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif ("raid" == string.sub(arg1, 1, 4)) then
				DoCheckRaidRageEnergy = true;
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "pet") then
				DoCheckUnitRageEnergy = true;
			elseif (arg1 == "player") then
				DoCheckRageEnergy = true;
			end		
		end
	
	elseif ( event == "UNIT_SPELLCAST_START"
	or event == "UNIT_SPELLCAST_CHANNEL_START"
	or event == "UNIT_SPELLCAST_DELAYED"
	or event == "UNIT_SPELLCAST_CHANNEL_UPDATE"
	or event == "UNIT_SPELLCAST_STOP"
	or event == "UNIT_SPELLCAST_FAILED"
	or event == "UNIT_SPELLCAST_INTERRUPTED"
	or event == "UNIT_SPELLCAST_CHANNEL_STOP" 
	or event == "UNIT_SPELLCAST_SUCCEEDED") then
		if (PowaModTest == false) then
			--- druid shapeshift special case
			if (event == "UNIT_SPELLCAST_SUCCEEDED") and arg1 and (arg1 == "player") 
			and ( (arg2 == GetSpellInfo(768)) or (arg2 == GetSpellInfo(5487)) or (arg2 == GetSpellInfo(9634)) ) then
				DoCheckMana = true;
				DoCheckRageEnergy = true;
			end
			--- spell alert handling
			if arg1 and not UnitIsDead(arg1) and UnitCanAttack(arg1, "player") then
				if UnitIsUnit(arg1, "target") then
					DoCheckTargetSpells = true;
				end
				if UnitIsUnit(arg1, "focus") then
					DoCheckFocusSpells = true;
				end
				DoCheckSpells = true; --- party/raidscan for casting units in this case
			end
		end
		
	elseif event == "PLAYER_FOCUS_CHANGED" then	  
		DoCheckFocusBuffs = true;
		DoCheckFocusHealth = true;
		DoCheckFocusMana = true;
		DoCheckFocusRageEnergy = true;
		DoCheckFocusSpells = true;

  elseif event == "UNIT_AURA" or event == "UNIT_AURASTATE" then  --- Buffs changed
    if (PowaModTest == false) then
			PowaDebug("Unit_aura fired.");
			if IsMounted() or IsFlying() then
				WeAreMounted = true;
			else
				WeAreMounted = false;
			end
	    if (arg1 == "target") then
		    DoCheckTargetBuffs = true;
      elseif ("party" == string.sub(arg1, 1, 5)) then 
	    	DoCheckPartyBuffs = true;
      elseif (arg1 == "focus") then
	      DoCheckFocusBuffs = true;
      elseif (string.sub(arg1, 1, 4) == "raid") then
	      DoCheckRaidBuffs = true;       
      elseif (arg1 == "player") then
				--- active les checks
				DoCheckBuffs = true;
			else
				DoCheckUnitBuffs = true;
      end
    end
        
	elseif event == "PLAYER_AURAS_CHANGED" then --- Player buff debuff changed
		if (PowaModTest == false) then
			PowaDebug("Player_auras_changed fired.");
			DoCheckBuffs = true;
		end	
	
	elseif event == "PLAYER_DEAD" then --- Player dead
		DoCheckAoe = true;
		DoResetAoe = true;
		DoCheckEnchant = true;
		WeAreMounted = false;
		DoCheckAction = true;
		WeAreAlive = false;
	
	elseif event == "PLAYER_ALIVE" or event == "PLAYER_UNGHOST" then
		if not UnitIsDeadOrGhost("player") then
			WeAreAlive = true;
			DoCheckBuffs = true;
			DoCheckHealth = true;
			DoCheckMana = true;
			DoCheckRageEnergy = true;
			DoCheckOthers = true;
			DoCheckCombo = true;
			DoCheckStance = true;
			DoCheckAction = true;
			DoCheckEnchant = true;
			DoCheckMounted = true;
			DoCheckPvP = true;
		end
	 
  elseif event == "PLAYER_TARGET_CHANGED" then  ---Target changed
		if (PowaModTest == false) then
			DoCheckTargetBuffs = true;
			DoCheckTargetHealth = true;
			DoCheckTargetMana = true;
			DoCheckTargetRageEnergy = true;
			ResetTargetTimers = true;
			DoCheckAction = true;
			DoCheckTargetSpells = true;
		end
	 
  elseif event == "PLAYER_REGEN_DISABLED" then  --- ic
		if (PowaModTest == false) then
			WeAreInCombat = true;
			DoCheckOthers = true;
			DoCheckEnchant = true;
			DoCheckTargetBuffs = true;
			DoCheckBuffs = true;
			DoCheckAction = true;
		end	   
	   
  elseif event == "PLAYER_REGEN_ENABLED" then --- ooc
		if (PowaModTest == false) then
			WeAreInCombat = false;
			DoCheckOthers = true;
			DoCheckEnchant = true;
			DoCheckTargetBuffs = true;
			DoCheckBuffs = true;
			DoCheckAction = true;
		end
     
	elseif event == "PLAYER_COMBO_POINTS" then --- deprecated in favor of UNIT_COMBO_POINTS
		if (PowaModTest == false) then
			DoCheckCombo = true; --- active les checks
		end
	
	elseif event == "UNIT_COMBO_POINTS" then
		if arg1 == "player" then
			if (PowaModTest == false) then
				DoCheckCombo = true;
			end
		end
	
	elseif event == "UNIT_ENTERED_VEHICLE" or event == "UNIT_EXITED_VEHICLE" then
		if arg1 == "player" then
			if UnitHasVehicleUI("player") and UnitIsUnit("vehicle", "pet") then
				WeAreInVehicle = true;
			else
				WeAreInVehicle = false;
			end
		end
	
	elseif event == "UNIT_FACTION" then --- GetPVPTimer() returns the time until unflag in ms
		if (PowaModTest == false) then
			if arg1 == "player" then
				DoCheckPvP = true;
			elseif arg1 == "target" then
				DoCheckTargetPvP = true;
			end
			local numpm = GetNumPartyMembers();
			if numpm > 0 then
				for i=1,numpm do
					if arg1 == "party"..i then
						DoCheckPartyPvP = true;
					end
				end
			end
			local numrm = GetNumRaidMembers();
			if numrm > 0 then
				for i=1, numrm do
					if arg1 == "raid"..i then
						DoCheckRaidPvP = true;
					end
				end
			end
		end
		
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		--- base args
		local tstamp,event,srcGUID,srcName,srcFlags,destGUID,destName,destFlags 
			= arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8;
		--- prefix args (conditional)
	  local pref1,pref2,pref3 
	  	= arg9,arg10,arg11;
	  --- suffix args (conditional)	
	  local suff1,suff2,suff3,suff4,suff5,suff6,suff7,suff8
	  	= arg12,arg13,arg14,arg15,arg16,arg17,arg18,arg19;
	   
	  local me = UnitName("player");
	  if destName and destName == me then
	  	if event == "SPELL_PERIODIC_DAMAGE" then
	  		if (PowaModTest == false) then
	  			if pref2 then
	  				AoeAuraAdded = pref2;
	  				DoCheckAoe = true;
	  			end
	  		end
	  	elseif event == "SPELL_AURA_REMOVED" then
	  		if (PowaModTest == false) then
	  			if pref2 then
	  				AoeAuraFaded = pref2;
	  				DoCheckAoe = true;
	  			end
	  		end
	  	end
	  end
	   
  elseif event == "ACTIONBAR_SLOT_CHANGED" then
		Powa_MemorizeActions(arg1);
		
	elseif event == "UPDATE_SHAPESHIFT_FORMS" then
		if PowaMisc.playerclass and (PowaMisc.playerclass == "WARRIOR" 
		or PowaMisc.playerclass == "DRUID" 
		or PowaMisc.playerclass == "ROGUE" 
		or PowaMisc.playerclass == "DEATHKNIGHT") then
			local numforms = GetNumShapeshiftForms();
			if numforms > 0 then
				for i=1, numforms do
					PowaStance[i] = select(2,GetShapeshiftFormInfo(i));
				end
			end
		end
		if (PowaModTest == false) then
			PowaDebug("UPDATE_SHAPESHIFT_FORMS");
			DoCheckStance = true;
		end
	
	elseif event == "ACTIONBAR_UPDATE_COOLDOWN" then
		if (PowaModTest == false) then
			PowaDebug("ACTIONBAR_UPDATE_COOLDOWN");
			PowaDebug("ACTIONBAR_UPDATE_USABLE");
			DoCheckAction = true;
			DoCheckStance = true;
			if IsMounted() or IsFlying() then
				WeAreMounted = true;
			else
				WeAreMounted = false;
			end
			for slot=1,120 do
				if HasAction(slot) then
					local start, duration, enable = GetActionCooldown(slot);
					if enable > 0 and start > 0 and duration > 0 then
						UsablePending[slot] = math.ceil(start + duration);
					else
						UsablePending[slot] = nil;
					end
				end
			end
--[[			for invslot=1,19 do
				local start, duration, enable = GetInventoryItemCooldown(invslot);
				if start > 0 and enable > 0 and duration > 0 then
					UsablePending[120+invslot] = math.ceil(start + duration);
				else
					UsablePending[120+invslot] = nil;
				end
			end ]]
		end	
		
	elseif event == "ACTIONBAR_UPDATE_USABLE" then
		if (PowaModTest == false) then
			PowaDebug("ACTIONBAR_UPDATE_USABLE");
			DoCheckAction = true;
			DoCheckStance = true;
			if IsMounted() or IsFlying() then
				WeAreMounted = true;
			else
				WeAreMounted = false;
			end
		end
	
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		if (PowaModTest == false) then
			PowaDebug("UPDATE_SHAPESHIFT_FORM");
			DoCheckStance = true;
			DoCheckAction = true;
		end
  
  end
end  --- function

function Powa_banzaiCallback(aggro, name, ...)
	local aggro, unitidentifikation;
	if name == UnitName("player") then
		DoCheckAggro = true;
		unitidentifikation = "player";
		aggro = Powa_banzai:GetUnitAggroByUnitName(name);
		if aggro then
			AggroStatus.unitidentifikation = true;
		else
			AggroStatus.unitidentifikation = nil;
		end	
	end
	local numpm = GetNumPartyMembers();
	local numrm = GetNumRaidMembers();
	if numpm > 0 then
		for i=1, numpm do
			if name == UnitName("party"..i) then
				DoCheckPartyAggro = true;
				unitidentifikation = "party"..i; 
				aggro = Powa_banzai:GetUnitAggroByUnitName(name);
				if aggro then
					AggroStatus.unitidentifikation = true;
				else
					AggroStatus.unitidentifikation = nil;
				end
			end
		end
	end
	if numrm > 0 then
		for i=1, numrm do
			if name == UnitName("raid"..i) then
				DoCheckRaidAggro = true;
				unitidentifikation = "raid"..i;
				aggro = Powa_banzai:GetUnitAggroByUnitName(name);
				if aggro then
					AggroStatus.unitidentifikation = true;
				else
					AggroStatus.unitidentifikation = nil;
				end
			end			
		end
	end
	
end

function PowaCustomTexPath(customname)
	local texpath;
	if string.find(customname,".", 1, true) then
		texpath = "Interface\\Addons\\PowerAuras\\Custom\\"..customname;
	else
		_, _, texpath = GetSpellInfo(customname);
	end
	if not texpath then texpath = "" end
	return texpath;
end

function PowaFloatToText(r,g,b,a)
	if ( type(r) == "table" ) then
		r, g, b, a = r.r, r.g, r.b, r.a;
	end
	a = min(1, a or 1) * 255
	r = min(1, r) * 255
	g = min(1, g) * 255
	b = min(1, b) * 255
	
	-- local fmt = "%.2x";
	return ("%.2x%.2x%.2x%.2x"):format(math_floor(a), math_floor(r), math_floor(g), math_floor(b))
end

--- ----------------------------------------------------------------------------------

function Powa_InitTabs()
	Powa_DefautAura(0);
end

--- ------------------------------------------------------------------------------------

function Powa_CreateFrames(xnum)

  if not (Powa_Frames[xnum]) then
  	--- Frame --- 
  	Powa_Frames[xnum] = CreateFrame("Frame","Frame"..xnum, UIParent);
    Powa_Frames[xnum]:SetFrameStrata("LOW");
  	Powa_Frames[xnum]:Hide();  
  	
	  Powa_Frames[xnum].baseL = 256;
	  Powa_Frames[xnum].baseH = 256;
		Powa_FramesVisibleTime[xnum] = 0;
  	
	end
	
	if not Powa_textures[xnum] then
		if PowaSet[xnum].textaura then
			Powa_textures[xnum] = Powa_Frames[xnum]:CreateFontString(nil, "OVERLAY");
			Powa_textures[xnum]:ClearAllPoints();
			Powa_textures[xnum]:SetPoint("CENTER",Powa_Frames[xnum]);
			Powa_textures[xnum]:SetFont(STANDARD_TEXT_FONT, 20);
			Powa_textures[xnum]:SetTextColor(PowaSet[xnum].r,PowaSet[xnum].g,PowaSet[xnum].b);
			Powa_textures[xnum]:SetJustifyH("CENTER");
		else
			Powa_textures[xnum] = Powa_Frames[xnum]:CreateTexture(nil,"BACKGROUND");
	  	Powa_textures[xnum]:SetBlendMode("ADD");
	  	Powa_textures[xnum]:SetAllPoints(Powa_Frames[xnum]); --- attache la texture a la frame
	  	Powa_Frames[xnum].texture = Powa_textures[xnum];
		end
	else
		if PowaSet[xnum].textaura then
			if Powa_textures[xnum]:GetObjectType() == "Texture" then
				Powa_textures[xnum]:SetTexture(nil);
				Powa_textures[xnum] = Powa_Frames[xnum]:CreateFontString(nil, "OVERLAY");
				Powa_textures[xnum]:ClearAllPoints();
				Powa_textures[xnum]:SetPoint("CENTER",Powa_Frames[xnum]);
				Powa_textures[xnum]:SetFont(STANDARD_TEXT_FONT, 20);
				Powa_textures[xnum]:SetTextColor(PowaSet[xnum].r,PowaSet[xnum].g,PowaSet[xnum].b);
				Powa_textures[xnum]:SetJustifyH("CENTER");
			end
		else
			if Powa_textures[xnum]:GetObjectType() == "FontString" then
				Powa_textures[xnum]:SetText("");
				Powa_textures[xnum] = Powa_Frames[xnum]:CreateTexture(nil,"BACKGROUND");
		  	Powa_textures[xnum]:SetBlendMode("ADD");	
		  	Powa_textures[xnum]:SetAllPoints(Powa_Frames[xnum]); --- attache la texture a la frame
		  	Powa_Frames[xnum].texture = Powa_textures[xnum];
			end
		end
	end	
  
end

Powa_Timer = {};
Powa_Timer2 = {};
Powa_timertex = {};
Powa_timertex2 = {};
Tstep = 0.09765625;

function Powa_CreateTimer(xnum)
	if not (Powa_Timer[xnum]) then
		Powa_Timer[xnum] = CreateFrame("Frame","Timer"..xnum);
		Powa_Timer[xnum]:SetFrameStrata("LOW");
		Powa_Timer[xnum]:Hide(); 
	
		Powa_timertex[xnum] = Powa_Timer[xnum]:CreateTexture(nil,"BACKGROUND");
		Powa_timertex[xnum]:SetBlendMode("ADD");
	
		Powa_timertex[xnum]:SetAllPoints(Powa_Timer[xnum]); --- attache la texture a la frame
		Powa_Timer[xnum].texture = Powa_timertex[xnum];
	
		Powa_timertex[xnum]:SetTexture("Interface\\Addons\\PowerAuras\\timers.tga");
	
		--- idem pour les secondes
		Powa_Timer2[xnum] = CreateFrame("Frame","Timer2"..xnum);
		Powa_Timer2[xnum]:SetFrameStrata("LOW");
		Powa_Timer2[xnum]:Hide(); 
	
		Powa_timertex2[xnum] = Powa_Timer2[xnum]:CreateTexture(nil,"BACKGROUND");
		Powa_timertex2[xnum]:SetBlendMode("ADD");
	
		Powa_timertex2[xnum]:SetAllPoints(Powa_Timer2[xnum]); --- attache la texture a la frame
		Powa_Timer2[xnum].texture = Powa_timertex2[xnum];
	
		Powa_timertex2[xnum]:SetTexture("Interface\\Addons\\PowerAuras\\timers.tga");
	end
	if not (PowaTimer[xnum]) then
		PowaTimer[xnum] = {
		x = 0, --- new
		y = 0,
		a = 1.00,
		h = 1.0,
		cents = true,
		dual = false
	};
	end
  Powa_UpdateOptionsTimer(xnum);
end

function Powa_CreateAuraString(anum)
	local tempstr, varpref= "", "";
	local i = 1;
	for k, v in pairs (PowaSet[anum]) do
		--- multi condition checks not supported for export.
		if k == "multiids" then
			v = "";
		end
		varpref = string.sub(type(v),1,2);
		tempstr = tempstr..k..":"..varpref..tostring(v).."; ";
		i = i+1;
	end
	if tempstr and tempstr ~= "" then
		tempstr = strtrim(tempstr);
		tempstr = string.sub(tempstr, 1, string.len(tempstr)-1);
	end
	PowaDebug("Aura-string length: "..tostring(string.len(tempstr)));
	return tempstr;
end

function Powa_ImportAura(anum, aurastring)

	local aurastring = string.gsub(aurastring,";%s*",";");
	local temptbl, importtbl = {strsplit(";", aurastring)}, {};
	local var, varpref, key = "", "", "";
	local vartype = {};
	vartype["st"] = "string";
	vartype["bo"] = "boolean";
	vartype["nu"] = "number";
	vartype["ni"] = "nil";

	for i, val in ipairs(temptbl) do
		key, var = strsplit(":", val);
		varpref = string.sub(var,1,2);
		var = string.sub(var,3);
		if vartype[varpref] == "string" then
			if var == "" then
				importtbl[key] = "";
			else
				importtbl[key] = var;
			end
		elseif vartype[varpref] == "boolean" then
			if var == "false" then
				importtbl[key] = false;
			elseif var == "true" then
				importtbl[key] = true;
			end
		elseif vartype[varpref] == "number" then
			importtbl[key] = tonumber(var);
		end
	end
	
	if (PowaSet[anum]) then
		for k, v in pairs(PowaSet[anum]) do
			PowaSet[anum][k] = importtbl[k];
		end
	end
end

--- ----------------------------------------------------------------------------------------------- CREE LA LISTE DES CHECKS

function Powa_CreateEffectLists()
	--- we are disabled, exit
	if (PowaEnabled == 0) then return; end   --- desactived
	
	ListBuffsMax = 0;
	ListTargetBuffsMax = 0;
	ListPartyBuffsMax = 0;
  ListRaidBuffsMax = 0;
  ListUnitBuffsMax = 0;
  ListFocusBuffsMax = 0;
	ListEnchantsMax = 0;
	ListComboMax = 0;
	ListAoeMax = 0;	
	ListActionsMax = 0;
	ListHealthMax = 0;
	ListManaMax = 0;
	ListRageEnergyMax = 0;
	ListFocusHealthMax = 0;
	ListFocusManaMax = 0;
	ListFocusRageEnergyMax = 0;
	ListTargetHealthMax = 0;
	ListTargetManaMax = 0;
	ListTargetRageEnergyMax = 0;
	ListPartyHealthMax = 0;
	ListPartyManaMax = 0;
	ListPartyRageEnergyMax = 0;
	ListRaidHealthMax = 0;
	ListRaidManaMax = 0;
	ListRaidRageEnergyMax = 0;
	ListUnitHealthMax = 0;
	ListUnitManaMax = 0;
	ListUnitRageEnergyMax = 0;
	ListStanceMax= 0;
	
	ListPvPMax = 0;
	ListPartyPvPMax = 0;
	ListRaidPvPMax = 0;
	ListTargetPvPMax = 0;
	
	ListAggroMax = 0;
	ListPartyAggroMax = 0;
	ListRaidAggroMax = 0;
		
	for i = 1, MaxAuras do
		--- non existing aura / no trigger / "off"
		if (PowaSet[i] == nil	or PowaSet[i].off == true) then
			--- skip non-existing and "off"
			--- Self Buffs
		elseif (PowaSet[i].bufftype == 1) then
			if not PowaSet[i].target 
		  and not PowaSet[i].targetfriend 
		  and not PowaSet[i].party
			and not PowaSet[i].raid 
			and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-buff
				ListBuffsMax = ListBuffsMax + 1;
				ListBuffs[ListBuffsMax] = i;
			end
			if PowaSet[i].party then --- partybuff cible
				ListPartyBuffsMax = ListPartyBuffsMax + 1;
				ListPartyBuffs[ListPartyBuffsMax] = i;
			end
			if PowaSet[i].focus then --- focus buffs
				ListFocusBuffsMax = ListFocusBuffsMax + 1;
				ListFocusBuffs[ListFocusBuffsMax] = i;
			end
			if PowaSet[i].raid then --- raid buffs
				ListRaidBuffsMax = ListRaidBuffsMax + 1;
				ListRaidBuffs[ListRaidBuffsMax] = i;
			end
			if PowaSet[i].optunitn then --- unit buffs
				ListUnitBuffsMax = ListUnitBuffsMax + 1;
				ListUnitBuffs[ListUnitBuffsMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- target buff
				ListTargetBuffsMax = ListTargetBuffsMax + 1;
				ListTargetBuffs[ListTargetBuffsMax] = i;
			end
	
		elseif (PowaSet[i].bufftype == 2) then
		  if not PowaSet[i].target 
		  and not PowaSet[i].targetfriend 
		  and not PowaSet[i].party 
			and not PowaSet[i].raid 
		  and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-debuff
				ListBuffsMax = ListBuffsMax + 1;
				ListBuffs[ListBuffsMax] = i;
			end
			if PowaSet[i].party then --- party debuff
				ListPartyBuffsMax = ListPartyBuffsMax + 1;
				ListPartyBuffs[ListPartyBuffsMax] = i;
			end
			if PowaSet[i].focus then --- focus debuff
				ListFocusBuffsMax = ListFocusBuffsMax + 1;
				ListFocusBuffs[ListFocusBuffsMax] = i;
			end
			if PowaSet[i].raid then --- raid debuff
				ListRaidBuffsMax = ListRaidBuffsMax + 1;
				ListRaidBuffs[ListRaidBuffsMax] = i;
			end
			if PowaSet[i].optunitn then --- unit debuff
				ListUnitBuffsMax = ListUnitBuffsMax + 1;
				ListUnitBuffs[ListUnitBuffsMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- target debuff
				ListTargetBuffsMax = ListTargetBuffsMax + 1;
				ListTargetBuffs[ListTargetBuffsMax] = i;
			end
		
		elseif (PowaSet[i].bufftype == 3) then
		  if not PowaSet[i].target
		  and not PowaSet[i].targetfriend
		  and not PowaSet[i].party
			and not PowaSet[i].raid
		  and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-debufftype
				ListBuffsMax = ListBuffsMax + 1;
				ListBuffs[ListBuffsMax] = i;
			end
			if PowaSet[i].party then --- partydebufftype cible
				ListPartyBuffsMax = ListPartyBuffsMax + 1;
				ListPartyBuffs[ListPartyBuffsMax] = i;
			end
			if PowaSet[i].focus then --- focus debufftype
				ListFocusBuffsMax = ListFocusBuffsMax + 1;
				ListFocusBuffs[ListFocusBuffsMax] = i;
			end
			if PowaSet[i].raid then --- raiddebufftype cible
				ListRaidBuffsMax = ListRaidBuffsMax + 1;
				ListRaidBuffs[ListRaidBuffsMax] = i;
			end
			if PowaSet[i].optunitn then --- unitdebufftype cible
				ListUnitBuffsMax = ListUnitBuffsMax + 1;
				ListUnitBuffs[ListUnitBuffsMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- targetdebufftype cible
				ListTargetBuffsMax = ListTargetBuffsMax + 1;
				ListTargetBuffs[ListTargetBuffsMax] = i;
			end
			
			---Other Events
		elseif (PowaSet[i].bufftype == 4) then --- AOE
			ListAoeMax = ListAoeMax + 1;
			ListAoe[ListAoeMax] = i;
			
		elseif (PowaSet[i].bufftype == 5) then --- Enchants
			ListEnchantsMax = ListEnchantsMax + 1;
			ListEnchants[ListEnchantsMax] = i;
			
		elseif (PowaSet[i].bufftype == 6) then --- Combo
			ListComboMax = ListComboMax + 1;
			ListCombo[ListComboMax] = i;
			
		elseif (PowaSet[i].bufftype == 7) then --- Actions ready
			ListActionsMax = ListActionsMax + 1;
			ListActions[ListActionsMax] = i;
		
		--- Health, Mana, Rage/Energy auralists	
		elseif (PowaSet[i].bufftype == 8) then --- Health
		  if not PowaSet[i].target 
		  and not PowaSet[i].targetfriend 
		  and not PowaSet[i].party 
			and not PowaSet[i].raid 
		  and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-health
				ListHealthMax = ListHealthMax + 1;
				ListHealth[ListHealthMax] = i;
			end
			if PowaSet[i].optunitn then --- unit health
				ListUnitHealthMax = ListUnitHealthMax + 1;
				ListUnitHealth[ListUnitHealthMax] = i;
			end
			if PowaSet[i].focus then --- focushealth      
				ListFocusHealthMax = ListFocusHealthMax + 1;
				ListFocusHealth[ListFocusHealthMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- TargetHealth
				ListTargetHealthMax = ListTargetHealthMax + 1;
				ListTargetHealth[ListTargetHealthMax] = i;
			end
			if PowaSet[i].party then --- partyhealth
				ListPartyHealthMax = ListPartyHealthMax + 1;
				ListPartyHealth[ListPartyHealthMax] = i;
			end
			if PowaSet[i].raid then --- raidhealth
				ListRaidHealthMax = ListRaidHealthMax + 1;
				ListRaidHealth[ListRaidHealthMax] = i;
			end
		
		elseif (PowaSet[i].bufftype == 9) then  --- mana
		  if not PowaSet[i].target
		  and not PowaSet[i].targetfriend
		  and not PowaSet[i].party
			and not PowaSet[i].raid
		  and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-mana
				ListManaMax = ListManaMax + 1;
				ListMana[ListManaMax] = i;
			end
			if PowaSet[i].optunitn then --- unit mana
				ListUnitManaMax = ListUnitManaMax + 1;
				ListUnitMana[ListUnitManaMax] = i;
			end
			if PowaSet[i].focus then --- focusmana
				ListFocusManaMax = ListFocusManaMax + 1;
				ListFocusMana[ListFocusManaMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- TargetMana
				ListTargetManaMax = ListTargetManaMax + 1;
				ListTargetMana[ListTargetManaMax] = i;
			end
			if PowaSet[i].party then --- partymana
				ListPartyManaMax = ListPartyManaMax + 1;
				ListPartyMana[ListPartyManaMax] = i;
			end
			if PowaSet[i].raid then --- raidmana
				ListRaidManaMax = ListRaidManaMax + 1;
				ListRaidMana[ListRaidManaMax] = i;
			end
		
		elseif (PowaSet[i].bufftype == 10) then --- energy/rage/power
		  if not PowaSet[i].target
		  and not PowaSet[i].targetfriend
		  and not PowaSet[i].party
			and not PowaSet[i].raid
		  and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self-energy or rage
				ListRageEnergyMax = ListRageEnergyMax + 1;
				ListRageEnergy[ListRageEnergyMax] = i;
			end
			if PowaSet[i].optunitn then --- unit energy or rage
				ListUnitRageEnergyMax = ListUnitRageEnergyMax + 1;
				ListUnitRageEnergy[ListUnitRageEnergyMax] = i;
			end
			if PowaSet[i].focus then --- focusrage or energy
				ListFocusRageEnergyMax = ListFocusRageEnergyMax + 1;
				ListFocusRageEnergy[ListFocusRageEnergyMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- Targetrage or energy
				ListTargetRageEnergyMax = ListTargetRageEnergyMax + 1;
				ListTargetRageEnergy[ListTargetRageEnergyMax] = i;	
			end
			if PowaSet[i].party then --- partyrage or energy
				ListPartyRageEnergyMax = ListPartyRageEnergyMax + 1;
				ListPartyRageEnergy[ListPartyRageEnergyMax] = i;
			end
			if PowaSet[i].raid then --- raidrage or energy
				ListRaidRageEnergyMax = ListRaidRageEnergyMax + 1;
				ListRaidRageEnergy[ListRaidRageEnergyMax] = i;
			end
	
		elseif (PowaSet[i].bufftype == 11) then--- Aggro
			if not PowaSet[i].target 
		  and not PowaSet[i].targetfriend 
		  and not PowaSet[i].party
			and not PowaSet[i].raid 
			and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self Aggro
		  	ListAggroMax = ListAggroMax + 1;
		  	ListAggro[ListAggroMax] = i;
		  end
		  if PowaSet[i].party then --- party Aggro
		  	ListPartyAggroMax = ListPartyAggroMax + 1;
		  	ListPartyAggro[ListPartyAggroMax] = i;
		  end
		  if PowaSet[i].raid then --- raid Aggro
		  	ListRaidAggroMax = ListRaidAggroMax + 1;
		  	ListRaidAggro[ListRaidAggroMax] = i;
		  end
	
		elseif (PowaSet[i].bufftype == 12) then --- PvP flag
			if not PowaSet[i].target 
		  and not PowaSet[i].targetfriend 
		  and not PowaSet[i].party
			and not PowaSet[i].raid 
			and not PowaSet[i].focus
		  and not PowaSet[i].optunitn then --- self pvp flag
		  	ListPvPMax = ListPvPMax + 1;
				ListPvP[ListPvPMax] = i;
			end
			if (PowaSet[i].target or PowaSet[i].targetfriend) then --- target flag
				ListTargetPvPMax = ListTargetPvPMax + 1;
				ListTargetPvP[ListTargetPvPMax] = i;
			end
			if PowaSet[i].party then --- party pvp flagged
				ListPartyPvPMax = ListPartyPvPMax + 1;
				ListPartyPvP[ListPartyPvPMax] = i;
			end
			if PowaSet[i].raid then --- raid pvp flagged
				ListRaidPvPMax = ListRaidPvPMax + 1;
				ListRaidPvP[ListRaidPvPMax] = i;
			end
		
		elseif (PowaSet[i].bufftype == 13) then --- Spellalert
			if not PowaSet[i].target
			and not PowaSet[i].focus then --- any enemy casts
				ListSpellsMax = ListSpellsMax + 1;
				ListSpells[ListSpellsMax] = i;
			end
			if PowaSet[i].target then --- target casts
				ListTargetSpellsMax = ListTargetSpellsMax + 1;
				ListTargetSpells[ListTargetSpellsMax] = i;
			end
			if PowaSet[i].focus then --- focus casts
				ListFocusSpellsMax = ListFocusSpellsMax + 1;
				ListFocusSpells[ListFocusSpellsMax] = i;
			end
		
		elseif (PowaSet[i].bufftype == 14) then --- stance
			ListStanceMax = ListStanceMax + 1;
			ListStance[ListStanceMax] = i;
		    
		end	
		--- ---------------------
	end --- end for i = 1, MaxAuras

	PowaDebug("Buffs : "..ListBuffsMax.." / Target Buffs : "..ListTargetBuffsMax.."/ Focus Buffs : "..ListFocusBuffsMax.." / Party Buffs : "..ListPartyBuffsMax.." / Raid Buffs : "..ListRaidBuffsMax.." / AOE Debuff : "..ListAoeMax.." / Enchants : "..ListEnchantsMax.." / Combos : "..ListComboMax.." / Actions : "..ListActionsMax.." / Health : "..ListHealthMax.." / Mana : "..ListManaMax.." / Stance : "..ListStanceMax);
end

--- ----------------------------------------------------------------------------------------------- Memorize les actions
function Powa_MemorizeActions(anum)
	local imin, imax;
	PowaDebug("---MemorizeActions---");
	if (ListActionsMax == 0) then
		return;
	end
	
	--- scan tout ou uniquement le slot qui a change
	if (anum == 0) then
		PowaDebug("---Scan all Actionbuttons---");
		imin = 1;
		imax = 120;
		--- reset tout
		for j = 1, ListActionsMax do
			PowaSet[ListActions[j]].opt1 = 0;
		end
	else
		imin = anum;
		imax = anum;
	end

	for i = imin, imax do
		if (HasAction(i)) then
			PowaDebug("---Has Action on button"..i.."---");
			PowaAction_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
		 	PowaAction_Tooltip:SetAction(i);
			local mytextline = getglobal("PowaAction_TooltipTextLeft1");		
			local text = mytextline:GetText();				
			if text and text ~= "" then
				PowaDebug("| "..text.." |");
			end	
			if (PowaAction_TooltipTextLeft1:IsShown()) then
				PowaDebug(PowaAction_TooltipTextLeft1:GetText());
				for j = 1, ListActionsMax do
					if((PowaSet[ListActions[j]].ignoremaj == true  and string.find(string.upper(PowaAction_TooltipTextLeft1:GetText()), string.upper(PowaSet[ListActions[j]].buffname), 1, true)) or
					   (PowaSet[ListActions[j]].ignoremaj == false and string.find(PowaAction_TooltipTextLeft1:GetText(), PowaSet[ListActions[j]].buffname, 1, true)) ) then --- on a trouve le slot
						PowaSet[ListActions[j]].opt1 = i; --- memorize le slot
						PowaDebug("---------------------------------------");
						PowaDebug("Actionname="..PowaSet[ListActions[j]].buffname.." / Search in Tooltipstring="..PowaAction_TooltipTextLeft1:GetText());
						--- prend la texture
						local tempicon;
						if (PowaSet[ListActions[j]].owntex == true) then
							getglobal("PowaIconTexture"):SetTexture(GetActionTexture(i));
							tempicon = getglobal("PowaIconTexture"):GetTexture();
							if (PowaSet[ListActions[j]].icon ~= tempicon) then
								PowaSet[ListActions[j]].icon = tempicon;
							end
						end
						if (PowaSet[ListActions[j]].icon == "") then
							getglobal("PowaIconTexture"):SetTexture(GetActionTexture(i));
							PowaSet[ListActions[j]].icon = getglobal("PowaIconTexture"):GetTexture();
						end
					end
				end
			end
			PowaAction_Tooltip:Hide();
		end
	end
end

--- ----------------------------------------------------------------------------------------------- BUFF CHECKS
function PowaCompareBuffDebuff(xnum)
	local buffIndex, untilCancelled;
	local curhealth, maxhealth, curpercenthp, curmana, maxmana, curpercentmp;
	local curenergy, maxenergy, curpercenteg;
	local typeDebuff;
	local unitidentifikation;
  local buffonpm = 0;
  local numpm = GetNumPartyMembers();
  local numrm = GetNumRaidMembers();
	PowaDebug("numPartymembers="..numpm.." / numRaidmembers="..numpm);

	local stacksOperator = PowaSet[xnum].stacksOperator or "=";
  local stacks = PowaSet[xnum].stacks or 0;
	
	if (PowaSet[xnum].bufftype == 6) then --- combos
		PowaDebug("Check Combos");
		local nCombo = GetComboPoints("player");
		if (string.find(PowaSet[xnum].buffname, tostring(nCombo))) then
			Powa_CreateFrames(xnum);
			if (PowaSet[xnum].icon == "") then
			  getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\inv_sword_48");
			  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
			end
			return true;
		end
	
	elseif (PowaSet[xnum].bufftype == 13) then --- Spell Alert
		PowaDebug("Spell Alerts");
		if (PowaSet[xnum].target) then
			local spellname, spellicon, _, endtime, isTradeSkill;
			unitidentifikation = "target";
			spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
			if not spellname then
				spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
			end
			if spellname then
				if PowaSet[xnum].exact == true then
					if PowaSet[xnum].buffname == spellname then
						Powa_CreateFrames(xnum);
						Powa_Frames[xnum].buffindex = endtime/1000;
						local tempicon;
						if (PowaSet[xnum].owntex == true) then
							getglobal("PowaIconTexture"):SetTexture(spellicon);
							tempicon = getglobal("PowaIconTexture"):GetTexture();
							if (PowaSet[xnum].icon ~= tempicon) then
								PowaSet[xnum].icon = tempicon;
							end
						end
						if (PowaSet[xnum].icon == "") then
						  getglobal("PowaIconTexture"):SetTexture(spellicon);
						  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
						end
						return true;
					end
				else
					for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
						if ( (PowaSet[xnum].ignoremaj == true 
						and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
						or (PowaSet[xnum].ignoremaj == false 
						and string.find(spellname, pword, 1, true)) ) then
							Powa_CreateFrames(xnum);
							Powa_Frames[xnum].buffindex = endtime/1000;
							local tempicon;
							if (PowaSet[xnum].owntex == true) then
								getglobal("PowaIconTexture"):SetTexture(spellicon);
								tempicon = getglobal("PowaIconTexture"):GetTexture();
								if (PowaSet[xnum].icon ~= tempicon) then
									PowaSet[xnum].icon = tempicon;
								end
							end
							if (PowaSet[xnum].icon == "") then
							  getglobal("PowaIconTexture"):SetTexture(spellicon);
							  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
							end
							return true;
						end
					end
				end
			end
		end
		if (PowaSet[xnum].focus) then
			local spellname, spellicon, endtime, isTradeSkill;
			unitidentifikation = "focus";
			spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
			if not spellname then
				spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
			end
			if spellname then
				if PowaSet[xnum].exact == true then
					if PowaSet[xnum].buffname == spellname then
						Powa_CreateFrames(xnum);
						Powa_Frames[xnum].buffindex = endtime/1000;
						local tempicon;
						if (PowaSet[xnum].owntex == true) then
							getglobal("PowaIconTexture"):SetTexture(spellicon);
							tempicon = getglobal("PowaIconTexture"):GetTexture();
							if (PowaSet[xnum].icon ~= tempicon) then
								PowaSet[xnum].icon = tempicon;
							end
						end
						if (PowaSet[xnum].icon == "") then
						  getglobal("PowaIconTexture"):SetTexture(spellicon);
						  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
						end
						return true;
					end
				else
					for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
						if ( (PowaSet[xnum].ignoremaj == true 
						and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
						or (PowaSet[xnum].ignoremaj == false 
						and string.find(spellname, pword, 1, true)) ) then
							Powa_CreateFrames(xnum);
							Powa_Frames[xnum].buffindex = endtime/1000;
							local tempicon;
							if (PowaSet[xnum].owntex == true) then
								getglobal("PowaIconTexture"):SetTexture(spellicon);
								tempicon = getglobal("PowaIconTexture"):GetTexture();
								if (PowaSet[xnum].icon ~= tempicon) then
									PowaSet[xnum].icon = tempicon;
								end
							end
							if (PowaSet[xnum].icon == "") then
							  getglobal("PowaIconTexture"):SetTexture(spellicon);
							  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
							end
							return true;
						end
					end
				end
			end	
		end	
		--- scrape for valid units
		--- start with player target/focus
		if (not PowaSet[xnum].focus and not PowaSet[xnum].target) then
			local spellname, spellicon, _, endtime, isTradeSkill;
			unitidentifikation = "target";
			spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
			if not spellname then
				spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
			end
			if spellname then
				if PowaSet[xnum].exact == true then
					if PowaSet[xnum].buffname == spellname then
						Powa_CreateFrames(xnum);
						Powa_Frames[xnum].buffindex = endtime/1000;
						local tempicon;
						if (PowaSet[xnum].owntex == true) then
							getglobal("PowaIconTexture"):SetTexture(spellicon);
							tempicon = getglobal("PowaIconTexture"):GetTexture();
							if (PowaSet[xnum].icon ~= tempicon) then
								PowaSet[xnum].icon = tempicon;
							end
						end
						if (PowaSet[xnum].icon == "") then
						  getglobal("PowaIconTexture"):SetTexture(spellicon);
						  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
						end
						return true;
					end
				else
					for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
						if ( (PowaSet[xnum].ignoremaj == true 
						and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
						or (PowaSet[xnum].ignoremaj == false 
						and string.find(spellname, pword, 1, true)) ) then
							Powa_CreateFrames(xnum);
							Powa_Frames[xnum].buffindex = endtime/1000;
							local tempicon;
							if (PowaSet[xnum].owntex == true) then
								getglobal("PowaIconTexture"):SetTexture(spellicon);
								tempicon = getglobal("PowaIconTexture"):GetTexture();
								if (PowaSet[xnum].icon ~= tempicon) then
									PowaSet[xnum].icon = tempicon;
								end
							end
							if (PowaSet[xnum].icon == "") then
							  getglobal("PowaIconTexture"):SetTexture(spellicon);
							  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
							end
							return true;
						end
					end
				end
			end
			unitidentifikation = "focus";
			spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
			if not spellname then
				spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
			end
			if spellname then
				if PowaSet[xnum].exact == true then
					if PowaSet[xnum].buffname == spellname then
						Powa_CreateFrames(xnum);
						Powa_Frames[xnum].buffindex = endtime/1000;
						local tempicon;
						if (PowaSet[xnum].owntex == true) then
							getglobal("PowaIconTexture"):SetTexture(spellicon);
							tempicon = getglobal("PowaIconTexture"):GetTexture();
							if (PowaSet[xnum].icon ~= tempicon) then
								PowaSet[xnum].icon = tempicon;
							end
						end
						if (PowaSet[xnum].icon == "") then
						  getglobal("PowaIconTexture"):SetTexture(spellicon);
						  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
						end
						return true;
					end
				else
					for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
						if ( (PowaSet[xnum].ignoremaj == true 
						and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
						or (PowaSet[xnum].ignoremaj == false 
						and string.find(spellname, pword, 1, true)) ) then
							Powa_CreateFrames(xnum);
							Powa_Frames[xnum].buffindex = endtime/1000;
							local tempicon;
							if (PowaSet[xnum].owntex == true) then
								getglobal("PowaIconTexture"):SetTexture(spellicon);
								tempicon = getglobal("PowaIconTexture"):GetTexture();
								if (PowaSet[xnum].icon ~= tempicon) then
									PowaSet[xnum].icon = tempicon;
								end
							end
							if (PowaSet[xnum].icon == "") then
							  getglobal("PowaIconTexture"):SetTexture(spellicon);
							  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
							end
							return true;
						end
					end
				end
			end
			--- move to raid/party target scanning
			if numrm > 0 then
				for i=1, numrm, 1 do
					unitidentifikation = "raid"..i.."target";
					if not UnitIsDead(unitidentifikation) and UnitCanAttack(unitidentifikation, "player") then
						spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
						if not spellname then
							spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
						end
						if spellname then
							if PowaSet[xnum].exact == true then
								if PowaSet[xnum].buffname == spellname then
									Powa_CreateFrames(xnum);
									Powa_Frames[xnum].buffindex = endtime/1000;
									local tempicon;
									if (PowaSet[xnum].owntex == true) then
										getglobal("PowaIconTexture"):SetTexture(spellicon);
										tempicon = getglobal("PowaIconTexture"):GetTexture();
										if (PowaSet[xnum].icon ~= tempicon) then
											PowaSet[xnum].icon = tempicon;
										end
									end
									if (PowaSet[xnum].icon == "") then
									  getglobal("PowaIconTexture"):SetTexture(spellicon);
									  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
									end
									return true;
								end
							else
								for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
									if ( (PowaSet[xnum].ignoremaj == true 
									and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
									or (PowaSet[xnum].ignoremaj == false 
									and string.find(spellname, pword, 1, true)) ) then
										Powa_CreateFrames(xnum);
										Powa_Frames[xnum].buffindex = endtime/1000;
										local tempicon;
										if (PowaSet[xnum].owntex == true) then
											getglobal("PowaIconTexture"):SetTexture(spellicon);
											tempicon = getglobal("PowaIconTexture"):GetTexture();
											if (PowaSet[xnum].icon ~= tempicon) then
												PowaSet[xnum].icon = tempicon;
											end
										end
										if (PowaSet[xnum].icon == "") then
										  getglobal("PowaIconTexture"):SetTexture(spellicon);
										  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
										end
										return true;
									end
								end
							end
						end
					end
				end
			end
			if numpm > 0 then
				for i=1, numpm, 1 do
					unitidentifikation = "party"..i.."target";
					if not UnitIsDead(unitidentifikation) and UnitCanAttack(unitidentifikation, "player") then
						spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitCastingInfo(unitidentifikation);
						if not spellname then
							spellname, _, _, spellicon, _, endtime, isTradeSkill, _ = UnitChannelInfo(unitidentifikation);
						end
						if spellname then
							if PowaSet[xnum].exact == true then
								if PowaSet[xnum].buffname == spellname then
									Powa_CreateFrames(xnum);
									Powa_Frames[xnum].buffindex = endtime/1000;
									local tempicon;
									if (PowaSet[xnum].owntex == true) then
										getglobal("PowaIconTexture"):SetTexture(spellicon);
										tempicon = getglobal("PowaIconTexture"):GetTexture();
										if (PowaSet[xnum].icon ~= tempicon) then
											PowaSet[xnum].icon = tempicon;
										end
									end
									if (PowaSet[xnum].icon == "") then
									  getglobal("PowaIconTexture"):SetTexture(spellicon);
									  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
									end
									return true;
								end
							else
								for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
									if ( (PowaSet[xnum].ignoremaj == true 
									and string.find(string.upper(spellname), string.upper(pword), 1, true)) 
									or (PowaSet[xnum].ignoremaj == false 
									and string.find(spellname, pword, 1, true)) ) then
										Powa_CreateFrames(xnum);
										Powa_Frames[xnum].buffindex = endtime/1000;
										local tempicon;
										if (PowaSet[xnum].owntex == true) then
											getglobal("PowaIconTexture"):SetTexture(spellicon);
											tempicon = getglobal("PowaIconTexture"):GetTexture();
											if (PowaSet[xnum].icon ~= tempicon) then
												PowaSet[xnum].icon = tempicon;
											end
										end
										if (PowaSet[xnum].icon == "") then
										  getglobal("PowaIconTexture"):SetTexture(spellicon);
										  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
										end
										return true;
									end
								end
							end
						end
					end
				end
			end
		end

	elseif (PowaSet[xnum].bufftype == 8) then --- Health changed
		PowaDebug("Check Health");
        --- Health
    if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			unitidentifikation = "target";
		elseif (PowaSet[xnum].focus) then
			unitidentifikation = "focus";
		elseif (PowaSet[xnum].party) then
			unitidentifikation = "party";
		elseif (PowaSet[xnum].raid) then
			unitidentifikation = "raid";
		elseif (PowaSet[xnum].optunitn) then
			unitidentifikation = PowaSet[xnum].unitn;
		else 
			unitidentifikation = "player";
		end	
		PowaDebug("on unit "..unitidentifikation);
		local UnitAlive, thresholdvalidate;
		if (unitidentifikation ~= "") 
		and not (unitidentifikation == "party") 
		and not (unitidentifikation == "raid") then			
			curhealth = UnitHealth(unitidentifikation);
			maxhealth = UnitHealthMax(unitidentifikation);
			curpercenthp = (curhealth / maxhealth) * 100;
			if PowaSet[xnum].thresholdinvert then 
				thresholdvalidate = (curpercenthp > PowaSet[xnum].threshold);
			else
				thresholdvalidate = (curpercenthp < PowaSet[xnum].threshold)
			end
			UnitAlive = true;
			if (UnitIsDeadOrGhost(unitidentifikation)) then
				UnitAlive = false;
			end				
		  if (thresholdvalidate == true) and (UnitAlive == true) then			        
				Powa_CreateFrames(xnum);					        
			 	if (PowaSet[xnum].icon == "") then
					getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
					PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
				end --- icone
				return true;
			end
		elseif (unitidentifikation == "party") then	
			for pm = 1, numpm do
				partyunitidentifikation = unitidentifikation..pm;
				curhealth = UnitHealth(partyunitidentifikation);
				maxhealth = UnitHealthMax(partyunitidentifikation);
				curpercenthp = (curhealth / maxhealth) * 100;			
				if (UnitIsDeadOrGhost(unitidentifikation)) then
					UnitAlive = false;
				end
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercenthp > PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercenthp < PowaSet[xnum].threshold)
				end
		   	if  (thresholdvalidate == true) and (UnitAlive == true) then			        
					Powa_CreateFrames(xnum);					        
			 		if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end
			end
		elseif (unitidentifikation == "raid") then
			for rm = 1, numrm do
				raidunitidentifikation = unitidentifikation..rm;
				curhealth = UnitHealth(raidunitidentifikation);
				maxhealth = UnitHealthMax(raidunitidentifikation);
				curpercenthp = (curhealth / maxhealth) * 100;		
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercenthp > PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercenthp < PowaSet[xnum].threshold);
				end
				if (UnitIsDeadOrGhost(unitidentifikation)) then
					UnitAlive = false;
				end	
		   	if  (thresholdvalidate == true) and (UnitAlive == true) then			        
					Powa_CreateFrames(xnum);					        
			 		if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end	
			end	
		end
		
	elseif (PowaSet[xnum].bufftype == 9) then --- Mana changed
		PowaDebug("Check Mana");
        --- Mana
   	if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			unitidentifikation = "target";
		elseif (PowaSet[xnum].focus) then
			unitidentifikation = "focus";
		elseif (PowaSet[xnum].party) then
			unitidentifikation = "party";
		elseif (PowaSet[xnum].raid) then
			unitidentifikation = "raid";
		elseif (PowaSet[xnum].optunitn) then
			unitidentifikation = PowaSet[xnum].unitn;
		else
			unitidentifikation = "player";
		end	
		PowaDebug("on unit "..unitidentifikation);
		local UnitAlive, thresholdvalidate;
		if (unitidentifikation ~= "") 
		and not (unitidentifikation == "party") 
		and not (unitidentifikation == "raid") then
			UnitAlive = true;
			if (UnitIsDeadOrGhost(unitidentifikation)) then
				UnitAlive = false;
			end	
			local powerType = UnitPowerType(unitidentifikation);
			if ( powerType ~= 0 ) then
				return false;
			end			
			curmana = UnitPower(unitidentifikation, powerType);
			maxmana = UnitPowerMax(unitidentifikation, powerType);
			curpercentmp = (curmana / maxmana) * 100;
			if PowaSet[xnum].thresholdinvert then 
				thresholdvalidate = (curpercentmp > PowaSet[xnum].threshold);
			else
				thresholdvalidate = (curpercentmp < PowaSet[xnum].threshold);
			end
		  if  (thresholdvalidate == true) and (UnitAlive == true) then			        
				Powa_CreateFrames(xnum);					        
			  if (PowaSet[xnum].icon == "") then
					getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
					PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
				end --- icone
				return true;
			end
		elseif (unitidentifikation == "party") then	
			for pm = 1, numpm do
				partyunitidentifikation = unitidentifikation..pm;
				if (UnitIsDeadOrGhost(partyunitidentifikation)) then
					UnitAlive = false;
				end	
				local powerType = UnitPowerType(partyunitidentifikation);
				if ( powerType ~= 0 ) then
					return false;
				end
				curmana = UnitPower(partyunitidentifikation, powerType);
				maxmana = UnitPowerMax(partyunitidentifikation, powerType);
				curpercentmp = (curmana / maxmana) * 100;			
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercentmp > PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercentmp < PowaSet[xnum].threshold);
				end
		    if  (thresholdvalidate == true) and (UnitAlive == true) then		        
					Powa_CreateFrames(xnum);					        
			  	if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end
			end	
		elseif (unitidentifikation == "raid") then
			for rm = 1, numrm do
				raidunitidentifikation = unitidentifikation..rm;
				if (UnitIsDeadOrGhost(raidunitidentifikation)) then
					UnitAlive = false;
				end	
				local powerType = UnitPowerType(raidunitidentifikation);
				if ( powerType ~= 0 ) then
					return false;
				end
				curmana = UnitPower(raidunitidentifikation, powerType);
				maxmana = UnitPowerMax(raidunitidentifikation, powerType);
				curpercentmp = (curmana / maxmana) * 100			
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercentmp > PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercentmp < PowaSet[xnum].threshold);
				end
		   	if  (thresholdvalidate == true) and (UnitAlive == true) then	        
					Powa_CreateFrames(xnum);					        
		  		if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end	
			end	
		end
	
	elseif (PowaSet[xnum].bufftype == 10) then --- Rage or Energy or RunicPower changed
		PowaDebug("Check Rage/Energy/RunicPower");
        --- Rage Energy RunicPower
   	if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			unitidentifikation = "target";
		elseif (PowaSet[xnum].focus) then
			unitidentifikation = "focus";
		elseif (PowaSet[xnum].party) then
			unitidentifikation = "party";
		elseif (PowaSet[xnum].raid) then
			unitidentifikation = "raid";
		elseif (PowaSet[xnum].optunitn) then
			unitidentifikation = PowaSet[xnum].unitn;
		else
			unitidentifikation = "player";
		end	
		PowaDebug("on unit "..unitidentifikation);
		local UnitAlive = true;
		local thresholdvalidate;
		if (unitidentifikation ~= "") 
		and not (unitidentifikation == "party") 
		and not (unitidentifikation == "raid") then		
			UnitAlive = true;
			if (UnitIsDeadOrGhost(unitidentifikation)) then
				UnitAlive = false;
			end	
			local powerType = UnitPowerType(unitidentifikation);
			if not ( powerType == 1 or powerType == 3 or powerType == 6 ) then
				return false;
			end	
			curenergy = UnitPower(unitidentifikation);
			maxenergy = UnitPowerMax(unitidentifikation);
			if curenergy == 0 then 
				curpercenteg = 0 
			else
				curpercenteg = (curenergy / maxenergy) * 100;
			end
			if PowaSet[xnum].thresholdinvert then 
				thresholdvalidate = (curpercenteg < PowaSet[xnum].threshold);
			else
				thresholdvalidate = (curpercenteg > PowaSet[xnum].threshold);
			end
		  if  (thresholdvalidate == true) and (UnitAlive == true) then			        
				Powa_CreateFrames(xnum);					        
			  if (PowaSet[xnum].icon == "") then
					getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
					PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
				end --- icone
				return true;
			end
		elseif (unitidentifikation == "party") then	
			for pm = 1, numpm do
				partyunitidentifikation = unitidentifikation..pm;
				if (UnitIsDeadOrGhost(partyunitidentifikation)) then
					UnitAlive = false;
				end	
				local powerType = UnitPowerType(partyunitidentifikation);
				if not ( powerType == 1 or powerType == 3 or powerType == 6 ) then
					return false;
				end
				curenergy = UnitPower(partyunitidentifikation);
				maxenergy = UnitPowerMax(partyunitidentifikation);
				curpercenteg = (curenergy / maxenergy) * 100;			
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercenteg < PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercenteg > PowaSet[xnum].threshold);
				end
		    if  (thresholdvalidate == true) and (UnitAlive == true) then		        
					Powa_CreateFrames(xnum);					        
			  	if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end
			end	
		elseif (unitidentifikation == "raid") then
			for rm = 1, numrm do
				raidunitidentifikation = unitidentifikation..rm;
				if (UnitIsDeadOrGhost(raidunitidentifikation)) then
					UnitAlive = false;
				end	
				local powerType = UnitPowerType(raidunitidentifikation);
				if not ( powerType == 1 or powerType == 3 or powerType == 6 ) then
					return false;
				end
				curenergy = UnitPower(raidunitidentifikation);
				maxenergy = UnitPowerMax(raidunitidentifikation);
				curpercenteg = (curenergy / maxenergy) * 100			
				if PowaSet[xnum].thresholdinvert then 
					thresholdvalidate = (curpercenteg < PowaSet[xnum].threshold);
				else
					thresholdvalidate = (curpercenteg > PowaSet[xnum].threshold);
				end
		   	if  (thresholdvalidate == true) and (UnitAlive == true) then	        
					Powa_CreateFrames(xnum);					        
		  		if (PowaSet[xnum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
				    PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end	
			end	
		end
	
	elseif (PowaSet[xnum].bufftype == 11) then --- Aggro status
		PowaDebug("Check Aggro status");
		if (PowaSet[xnum].party) then
			unitidentifikation = "party";
		elseif (PowaSet[xnum].raid) then
			unitidentifikation = "raid";
		else
			unitidentifikation = "player";
		end
		PowaDebug("on unit "..unitidentifikation);
		if unitidentifikation == "player" then
			if AggroStatus.unitidentifikation then
				return true;
			end
		elseif unitidentifikation == "party" then
			for pm = 1, numpm do
				unitidentifikation = "party"..pm;
				if AggroStatus.unitidentifikation then
					return true;
				end
			end
		elseif unitidentifikation == "raid" then
			for rm = 1, numrm do
				unitidentifikation = "raid"..rm;
				if AggroStatus.unitidentifikation then
					return true;
				end
			end
		end
	
	elseif (PowaSet[xnum].bufftype == 11) then --- PvP Flagged
		PowaDebug("Check PvP Flag");
		if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			unitidentifikation = "target";
		elseif (PowaSet[xnum].party) then
			unitidentifikation = "party";
		elseif (PowaSet[xnum].raid) then
			unitidentifikation = "raid";
		else
			unitidentifikation = "player";
		end
		PowaDebug("on unit "..unitidentifikation);
		if unitidentifikation == "player" then
			if UnitIsPVP(unitidentifikation) then
				return true;
			end
		elseif unitidentifikation == "target" then
			if UnitIsPVP(unitidentifikation) then
				return true;
			end
		elseif unitidentifikation == "party" then
			for pm = 1, numpm do
				if UnitIsPVP("party"..pm) then
					return true;
				end
			end
		elseif unitidentifikation == "raid" then
			for rm = 1, numrm do
				if UnitIsPVP("raid"..rm) then
					return true;
				end
			end
		end
	
	elseif (PowaSet[xnum].bufftype == 14) then --- Stance
	  PowaDebug("Check Stance");
	  local nStance = "";
	  if PowaMisc.playerclass and PowaMisc.playerclass == "DEATHKNIGHT" then
	  	nStance = GetShapeshiftForm(false);
	  else
			nStance = GetShapeshiftForm(true); 
		end
    PowaDebug("nStance = "..nStance.." / PowaSet[xnum].stance = "..PowaSet[xnum].stance);
		if (nStance == PowaSet[xnum].stance) then
		  return true;
    else            
      return false;		    
    end	
		
	elseif (PowaSet[xnum].bufftype == 7) then --- Actions utilisables
		PowaDebug("Check Action / Button:"..PowaSet[xnum].opt1);
		if (PowaSet[xnum].opt1 == 0) then 
      return false; 
    end --- inactif / pas d'action sur les barres

		local isUsable, _ = IsUsableAction(PowaSet[xnum].opt1);
		local cdstart, cdduration, _ = GetActionCooldown(PowaSet[xnum].opt1);
    ---	local inRange = IsActionInRange(PowaSet[xnum].opt1); --- portee
    PowaDebug("cdstart= "..cdstart.." duration= "..cdduration);
		if (cdduration < 1.7 and cdduration > 0.2 and PowaSet[xnum].gcd == false) then
		  if (isUsable == 1) then --- utilisable, pas de cooldown
		    return true;
		  end
    else
      if (isUsable == 1 and cdstart == 0) then
       	return true;
		  end
    end
			
	elseif (PowaSet[xnum].bufftype == 4) then --- AOE
		PowaDebug("Check AoE");
		if (DoResetAoe == true) then --- probablement mort, on reset l'effet
			return false;
		elseif (AoeAuraAdded ~= "") then --- debuff ajoute
		 	if PowaSet[xnum].exact == true then
				if PowaSet[xnum].buffname == AoeAuraAdded then
					Powa_CreateFrames(xnum);
					Powa_Frames[xnum].buffindex = 1; --- point vers le buff qui a le timer
					if (PowaSet[xnum].icon == "") then
					  getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
					  PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
					end
					return true;
				end
			else	
				for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
					if ( (PowaSet[xnum].ignoremaj == true 
					and string.find(string.upper(AoeAuraAdded), string.upper(pword), 1, true)) 
					or (PowaSet[xnum].ignoremaj == false 
					and string.find(AoeAuraAdded, pword, 1, true)) ) then
						Powa_CreateFrames(xnum);
						Powa_Frames[xnum].buffindex = 1; --- point vers le buff qui a le timer
						if (PowaSet[xnum].icon == "") then
					 	 	getglobal("PowaIconTexture"):SetTexture("Interface\\icons\\Spell_fire_meteorstorm");
					   	PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
						end
						return true;
					end
				end
			end
		elseif (AoeAuraFaded ~= "") then --- debuff retire
			for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
				if ( (PowaSet[xnum].ignoremaj == true 
				and string.find(string.upper(AoeAuraFaded), string.upper(pword), 1, true)) 
				or (PowaSet[xnum].ignoremaj == false 
				and string.find(AoeAuraFaded, pword, 1, true)) ) then
					Powa_CreateFrames(xnum);
					Powa_Frames[xnum].buffindex = 1; --- point vers le buff qui a le timer
					return false;
				end
			end
		end
		if (Powa_FramesVisibleTime[xnum] == 0) then --- pas visible
			return false;
		else
			return true;
		end
	elseif (PowaSet[xnum].bufftype == 5) then --- enchant
		PowaDebug("Check enchant");
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();		
		if (hasMainHandEnchant) then		
			if (Powa_CheckforMainEnchant(xnum)) then
				PowaDebug("MH:found "..PowaSet[xnum].buffname.." in the tooltip!");
				if (stacksOperator == "=" and stacks == 0)
				or (stacksOperator == "<" and mainHandCharges < stacks)
				or (stacksOperator == ">" and mainHandCharges > stacks)
				or (stacksOperator == "=" and mainHandCharges == stacks)
				or (stacksOperator == "!" and mainHandCharges ~= stacks) then
					Powa_CreateFrameMainEnchant(xnum)
					return true;
				end
			end			
		end
		if (hasOffHandEnchant) then
			if (Powa_CheckforOffEnchant(xnum)) then
				PowaDebug("OH:found "..PowaSet[xnum].buffname.." in the tooltip!");
				if (stacksOperator == "=" and stacks == 0)
				or (stacksOperator == "<" and offHandCharges < stacks)
				or (stacksOperator == ">" and offHandCharges > stacks)
				or (stacksOperator == "=" and offHandCharges == stacks)
				or (stacksOperator == "!" and offHandCharges ~= stacks) then
					Powa_CreateFrameOffEnchant(xnum)
					return true;
				end
			end	
		end	
			
	elseif (PowaSet[xnum].bufftype == 2) then --- a debuff
		PowaDebug("Check debuff");
    --- target debuff
    if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			PowaDebug("on target or friendlytarget");
		  for i = 1, 40 do
		  	if (Powa_IsBuffedChecker("debuff", "target", xnum, i)) then
					return true;
				end	
		  end		
      --- focus debuff   
   	elseif PowaSet[xnum].focus then
			PowaDebug("on focus");
		  for i = 1, 40 do
		    if (Powa_IsBuffedChecker("debuff", "focus", xnum, i)) then
					return true;
				end	
		  end
      --- unit debuff   
    elseif PowaSet[xnum].optunitn then
			PowaDebug("on unit "..PowaSet[xnum].unitn);
		  for i = 1, 40 do
		    if (Powa_IsBuffedChecker("debuff", PowaSet[xnum].unitn, xnum, i)) then
					return true;
				end	
		  end
      --- party debuff   
    elseif (PowaSet[xnum].party) then --- Partymember Debuff
			PowaDebug("on partyunit");
      for partym = 1, numpm do
	      for i = 1, 40 do
					if (Powa_IsBuffedChecker("debuff", "party"..partym, xnum, i)) then
						return true;
					end	
        end
      end
      --- raid debuff    
    elseif (PowaSet[xnum].raid) then --- Raidmember Debuff
			PowaDebug("on raidunit");
      for raidm = 1, numrm do
	      for i = 1, 40 do
		    	if (Powa_IsBuffedChecker("debuff", "raid"..raidm, xnum, i)) then
						return true;
					end	
        end
      end     	 
		--- Player Debuff
    else
			PowaDebug("on player");
			PowaDebug("search deBuffName = "..PowaSet[xnum].buffname);
		  for i = 1, 40 do
		    if (Powa_IsBuffedChecker("debuff", "player", xnum, i)) then
					return true;
				end	
		  end
    end
		
	elseif (PowaSet[xnum].bufftype == 3) then --- type de debuff
		PowaDebug("Check debuff type");
    if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			PowaDebug("on target or friendlytarget");
		  for i = 1, 40 do
				if (Powa_CompareDebufftypes("target", xnum, i)) then
					return true;
				end			        
		  end
      --- focus    
    elseif PowaSet[xnum].focus then
			PowaDebug("on focus");
		  for i = 1, 40 do
				if (Powa_CompareDebufftypes("focus", xnum, i)) then
					return true;
				end	
		  end
        --- unit    
    elseif PowaSet[xnum].optunitn then
			PowaDebug("on unit "..PowaSet[xnum].unitn);
		  for i = 1, 40 do
				if (Powa_CompareDebufftypes(PowaSet[xnum].unitn, xnum, i)) then
					return true;
				end	
		  end         
		--- Party Debufftype
    elseif (PowaSet[xnum].party) then
			PowaDebug("on partyunit");
      for partymdb = 1, numpm do ---Partymembers Debuff
        for i = 1, 40 do
					if (Powa_CompareDebufftypes("party"..partymdb, xnum, i)) then
						return true;
					end	
        end
      end  
    --- Raid Debufftype
    elseif (PowaSet[xnum].raid) then
			PowaDebug("on raidunit");
      for raidmdb = 1, numrm do ---Raidmembers Debuff
        for i = 1, 40 do
					if (Powa_CompareDebufftypes("raid"..raidmdb, xnum, i)) then
						return true;
					end	
				end	 
      end
    --- Player Debufftype
    else 
			PowaDebug("on player");
			PowaDebug("search deBuffName = "..PowaSet[xnum].buffname);
      for i = 1, 40 do
				if (Powa_CompareDebufftypes("player", xnum, i)) then
					return true;
				end	
      end
    end
		
	elseif (PowaSet[xnum].bufftype == 1) then --- un buff 
		PowaDebug("Check buff");
		--- targets
    if (PowaSet[xnum].target or PowaSet[xnum].targetfriend) then
			PowaDebug("on target or friendlytarget");
      for i = 1, 40 do
		  	if (Powa_IsBuffedChecker("buff", "target", xnum, i)) then
					return true;
				end	
		  end	
			
    --- focus buff    
    elseif PowaSet[xnum].focus then
			PowaDebug("on focus");
      for i = 1, 40 do
      	if (Powa_IsBuffedChecker("buff", "focus", xnum, i)) then
      		return true;
      	end
      end
			
    --- unit buff    
    elseif PowaSet[xnum].optunitn then
			PowaDebug("on unit "..PowaSet[xnum].unitn);
      for i = 1, 40 do
		    if (Powa_IsBuffedChecker("buff", PowaSet[xnum].unitn, xnum, i)) then
         	return true;
				end	
      end
			
    --- partybuff    
    elseif PowaSet[xnum].party then
			PowaDebug("on partyunit");
			local buffonpm = 0;
			local buffonany = PowaSet[xnum].groupany;
      for partymb = 1, numpm do		
		    for i = 1, 40 do
		    	if (Powa_IsBuffedChecker("buff", "party"..partymb, xnum, i)) then
		    		if buffonany == true then
		    			return true;
		    		else
							buffonpm = buffonpm + 1;
						end
					end	
		    end
	    end
      if (buffonpm == numpm) then              
        return true;
      end
			
    --- raid buff
    elseif PowaSet[xnum].raid then
			PowaDebug("on raidunit");
			local buffonrm = 0;
			local buffonany = PowaSet[xnum].groupany;
      for raidmb = 1, numrm do
		    for i = 1, 40 do
		      if (Powa_IsBuffedChecker("buff", "raid"..raidmb, xnum, i)) then
			      if buffonany == true then
			      	return true;
			      else
							buffonrm = buffonrm + 1;
						end
					end	
		    end
	    end
      if (buffonrm == numrm) then         
        return true;
      end
			
    --- player buff    
    else
			PowaDebug("on player");
			PowaDebug("search BuffName = "..PowaSet[xnum].buffname);
		  for i = 1, 40 do
		    if (Powa_IsBuffedChecker("buff", "player", xnum, i)) then
					return true;
				end	
		  end
	  end          
  end
  
	return false;
end

function PowaCheckMultiple(xnum)
	local bResult = true;
	local numpm, numrm = GetNumPartyMembers(), GetNumRaidMembers();
	if (PowaSet[xnum].multiids ~= "") then
		local k;
		if string.find(PowaSet[xnum].multiids, "[^0-9/]") then --- invalid input (only numbers and / allowed)
			PowaDebug("Multicheck. Invalid Input. Only numbers and '/' allowed.");
		else
			for pword in string.gmatch(PowaSet[xnum].multiids, "[^/]+") do
				k = tonumber(pword);
				if PowaSet[k] then
					--- trivial checks first
					--- player aura but player is dead
					if ((not PowaSet[k].target) 
				  and (not PowaSet[k].targetfriend)
				  and (not PowaSet[k].party)
					and (not PowaSet[k].raid) 
					and (not PowaSet[k].focus)
				  and (not PowaSet[k].optunitn) 
				  and (WeAreAlive == false)) then
				  	bResult = false;
				  end
					--- n'affiche pas si la cible est inexistante ou morte
					if ((PowaSet[k].target or PowaSet[k].targetfriend) and (UnitName("target") == nil or UnitIsDead("target") or UnitName("target") == UnitName("player")) ) then
						bResult = false;
					end
					--- regarde si la cible est ennemie
					if (PowaSet[k].target and PowaSet[k].targetfriend == false and UnitIsFriend("player","target")) then --- cible amie alors que faut pas
						bResult = false;
					end
					--- party
					if (PowaSet[k].party and not ((numpm > 0) or (numrm > 0))) then --- partycheck yes, but not in party
						bResult = false;
					end
				    --- focus
					if (PowaSet[k].focus and (UnitName("focus") == nil or UnitIsDead("focus") or UnitName("focus") == UnitName("player"))) then --- focuscheck
						bResult = false;
					end
				    --- unit
					if (PowaSet[k].optunitn and not ((numpm > 0) or (numrm > 0) or UnitExists("pet"))) then --- Unitn yes, but not in party/raid or with pet
						bResult = false;
					end
				    --- raid
					if (PowaSet[k].raid and not (numrm > 0)) then --- raidcheck yes, but not in raid
						bResult = false;
					end
					--- regarde si la cible est amie
					if (PowaSet[k].target == false and PowaSet[k].targetfriend and not UnitIsFriend("player","target")) then --- cible ennemie
						bResult = false;
					end
					--- mode combat, cache si besoin
					if ((WeAreInCombat == true and PowaSet[k].combat == 2) or (WeAreInCombat == false and PowaSet[k].combat == 1)) then
						bResult = false;
					end
					if (WeAreInRaid == false and PowaSet[k].isinraid == true) then
						bResult = false;
					end	
					if (WeAreMounted ~= PowaSet[k].ismounted) then	
						bResult = false;	
					end
					--- we passed the trivial checks
					--- move on to the activation trigger
					if bResult==true then
						local bTemp = PowaCompareBuffDebuff(k);
						if PowaSet[k].inverse then
							bResult = not bTemp;
						else
							bResult = bTemp and true;
						end
					end
									
					if bResult == false then break end --- if any aura id fails exit the loop		
				
				else
					PowaDebug("Multicheck. Non-existant Aura ID specified: "..pword);
				end
			end
		end
	end
	
	return bResult;
	
end

function Powa_CheckforMainEnchant(xnum)
	PowaDebug("Has mainhand enchant activ.");
	local ret, wpnflag = false, false;
	local text = "";
	Powa_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
	Powa_Tooltip:SetInventoryItem("player", 16);
	--- Powa_Tooltip:SetPlayerBuff(buffIndexpassive);
	PowaDebug("search in mainhand tooltip:");			
	for z = 1, Powa_Tooltip:NumLines() do
		local textlinel,textliner = getglobal("Powa_TooltipTextLeft"..z),getglobal("Powa_TooltipTextRight"..z);
		local textl,textr = textlinel:GetText(), textliner:GetText();
		if textl and textl ~= "" then
			text = text..textl;
		end
		if textr and textr ~= "" then
			text = text..textr;
		end
		if (text ~= "") then
			PowaDebug("| "..text.." |");
			if string.find(PowaSet[xnum].buffname, "/", 1, true) then
				for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
					if (not wpnflag) and ( (PowaSet[xnum].ignoremaj == true and string.upper(pword) == string.upper(PowaText.mainHand))
					or (PowaSet[xnum].ignoremaj == false and pword ==	PowaText.mainHand ) ) then
						wpnflag = true;
					end
					if ( (PowaSet[xnum].ignoremaj == true and string.find(string.upper(text), string.upper(pword), 1, true))
					or   (PowaSet[xnum].ignoremaj == false and string.find(text, pword, 1, true)) ) then
						ret = true;
					end
				end
				ret = ret and wpnflag;
			else
			if ( (PowaSet[xnum].ignoremaj == true and string.find(string.upper(text), string.upper(PowaSet[xnum].buffname), 1, true))
			or   (PowaSet[xnum].ignoremaj == false and string.find(text, PowaSet[xnum].buffname, 1, true)) ) then --- droite
					ret = true;
			end	
		end
	end	
		text = "";
	end	
	Powa_Tooltip:Hide();
	return ret;		
end

function Powa_CreateFrameMainEnchant(xnum)
	Powa_CreateFrames(xnum);
	if (PowaSet[xnum].icon == "") then
		getglobal("PowaIconTexture"):SetTexture( GetInventoryItemTexture("player", 16) );
		PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
	end --- icone
	Powa_Frames[xnum].buffindex = 1;
end	

function Powa_CreateFrameOffEnchant(xnum)
	Powa_CreateFrames(xnum);
	if (PowaSet[xnum].icon == "") then
		getglobal("PowaIconTexture"):SetTexture( GetInventoryItemTexture("player", 17) );
		PowaSet[xnum].icon = getglobal("PowaIconTexture"):GetTexture();
	end --- icone
	Powa_Frames[xnum].buffindex = 2;
end	
						

function Powa_CheckforOffEnchant(xnum)
	PowaDebug("Has offhand enchant activ.");
	local ret, wpnflag = false, false;
	local text = "";
	Powa_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");
	Powa_Tooltip:SetInventoryItem("player", 17);
	--- Powa_Tooltip:SetPlayerBuff(buffIndexpassive);
	PowaDebug("search in offhand tooltip:");			
	for z = 1, Powa_Tooltip:NumLines() do
		local textlinel,textliner = getglobal("Powa_TooltipTextLeft"..z),getglobal("Powa_TooltipTextRight"..z);
		local textl,textr = textlinel:GetText(), textliner:GetText();
		if textl and textl ~= "" then
			text = text..textl;
		end
		if textr and textr ~= "" then
			text = text..textr;
		end
		if (text ~= "") then
			PowaDebug("| "..text.." |");
			if string.find(PowaSet[xnum].buffname, "/", 1, true) then
				for pword in string.gmatch(PowaSet[xnum].buffname, "[^/]+") do
					if (not wpnflag) and ( (PowaSet[xnum].ignoremaj == true and string.upper(pword) == string.upper(PowaText.offHand))
					or (PowaSet[xnum].ignoremaj == false and pword ==	PowaText.offHand ) ) then
						wpnflag = true;
					end
					if ( (PowaSet[xnum].ignoremaj == true and string.find(string.upper(text), string.upper(pword), 1, true))
					or   (PowaSet[xnum].ignoremaj == false and string.find(text, pword, 1, true)) ) then
						ret = true;
					end
				end
				ret = ret and wpnflag;
			else
			if ( (PowaSet[xnum].ignoremaj == true and string.find(string.upper(text), string.upper(PowaSet[xnum].buffname), 1, true))
			or   (PowaSet[xnum].ignoremaj == false and string.find(text, PowaSet[xnum].buffname, 1, true)) ) then --- droite
					ret = true;
			end	
		end
	end	
		text = "";
	end	

	Powa_Tooltip:Hide();
	return ret;		
end

function Powa_IsBuffedChecker(bufftype, unittarget, snum, s)
	
	local stacksOperator = PowaSet[snum].stacksOperator or "=";
	local stacks = PowaSet[snum].stacks or 0;
	local bemine = PowaSet[snum].mine;

	if (bufftype == "debuff") then   --- DEBUFF checking
		local debuffname, _, _, count, _, _, _, isMine  = UnitAura(unittarget, s, "HARMFUL");
		if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
		if debuffname then
			if (Powa_CompareDebuffs(unittarget, snum, s)) then
				PowaDebug("Check Debuff "..PowaSet[snum].buffname.." on "..unittarget.." that "..stacksOperator.." "..stacks.." stacks. Result: "..count.." stacks.");
				if (bemine and isMine) or (not bemine) then
					if ((stacksOperator == "=" and stacks == 0)
					or (stacksOperator == ">" and count > stacks)
					or (stacksOperator == "<" and count < stacks)
					or (stacksOperator == "=" and count == stacks)
					or (stacksOperator == "!" and count ~= stacks)) then
						return true;
					end
				end
			end		
		end	
		
	elseif (bufftype == "buff") then	--- BUFF Checking
		local buffname, _, _, count, _, _, _, isMine = UnitAura(unittarget, s, "HELPFUL");
		if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
		if buffname then
			PowaDebug("Check buff "..PowaSet[snum].buffname.." on "..unittarget.." that "..stacksOperator.." "..stacks.." stacks. Result: "..count.." stacks.");					
			if (Powa_CompareBuffs(unittarget, snum, s)) then
				if (bemine and isMine) or (not bemine) then
					if ((stacksOperator == "=" and stacks == 0)
					or (stacksOperator == ">" and count > stacks)
					or (stacksOperator == "<" and count < stacks)
					or (stacksOperator == "=" and count == stacks)
					or (stacksOperator == "!" and count ~= stacks)) then
						return true;
					end
				end
			end
		end	
	end
	
	return false;
end	

function Powa_CompareBuffs(target, znum, z)
	local buffname, _ , bufftexture = UnitAura(target, z, "HELPFUL");
	if buffname then
		if (PowaSet[znum].exact == true) then
			if PowaSet[znum].buffname == buffname then
				Powa_CreateFrames(znum);
				Powa_Frames[znum].buffindex = z;
				local tempicon;
				if (PowaSet[znum].owntex == true) then
					getglobal("PowaIconTexture"):SetTexture(bufftexture);
					tempicon = getglobal("PowaIconTexture"):GetTexture();
					if (PowaSet[znum].icon ~= tempicon) then
						PowaSet[znum].icon = tempicon;
					end
				end
				if (PowaSet[znum].icon == "") then
					getglobal("PowaIconTexture"):SetTexture(bufftexture);
					PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
				end --- icone
		    return true;
	  	end	
		else		
			for pword in string.gmatch(PowaSet[znum].buffname, "[^/]+") do
	  		if ( (PowaSet[znum].ignoremaj == true and string.find(string.upper(UnitAura(target, z, "HELPFUL")), string.upper(pword), 1, true)) 
	  		or   (PowaSet[znum].ignoremaj == false and string.find(buffname, pword, 1, true)) ) then
					Powa_CreateFrames(znum);
					Powa_Frames[znum].buffindex = z;
					local tempicon;
					if (PowaSet[znum].owntex == true) then
						getglobal("PowaIconTexture"):SetTexture(bufftexture);
						tempicon = getglobal("PowaIconTexture"):GetTexture();
						if (PowaSet[znum].icon ~= tempicon) then
							PowaSet[znum].icon = tempicon;
						end
					end
					if (PowaSet[znum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture(bufftexture);
						PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
	  		end
			end		
   	end
  end
	return false;
end

function Powa_CompareDebuffs(target, znum, z)
	local debuffnamez, _, TextureIconn, count, _, _, _ = UnitAura(target, z, "HARMFUL");
	PowaDebug("CompareDebuffs "..target.." "..znum.." "..z);
	if debuffnamez then
		if PowaSet[znum].exact == true then
			if (PowaSet[znum].buffname == debuffnamez) then
				Powa_CreateFrames(znum);
				Powa_Frames[znum].buffindex = z; --- point vers le debuff qui a le timer
				local tempicon;
				if (PowaSet[znum].owntex == true) then
					getglobal("PowaIconTexture"):SetTexture(TextureIconn);
					tempicon = getglobal("PowaIconTexture"):GetTexture();
					if (PowaSet[znum].icon ~= tempicon) then
						PowaSet[znum].icon = tempicon;
					end
				end
				if (PowaSet[znum].icon == "") then
					getglobal("PowaIconTexture"):SetTexture(TextureIconn);
					PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
				end --- icone
				return true;
			end
		else
			for pword in string.gmatch(PowaSet[znum].buffname, "[^/]+") do											
				if ( (PowaSet[znum].ignoremaj == true and string.find(string.upper(debuffnamez), string.upper(pword), 1, true)) 
				or   (PowaSet[znum].ignoremaj == false and string.find(debuffnamez, pword, 1, true)) ) then								
					Powa_CreateFrames(znum);
					Powa_Frames[znum].buffindex = z; --- point vers le debuff qui a le timer
					local tempicon;
					if (PowaSet[znum].owntex == true) then
						getglobal("PowaIconTexture"):SetTexture(TextureIconn);
						tempicon = getglobal("PowaIconTexture"):GetTexture();
						if (PowaSet[znum].icon ~= tempicon) then
							PowaSet[znum].icon = tempicon;
						end
					end
					if (PowaSet[znum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture(TextureIconn);
						PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;									
				end
			end
		end		
	end
	return false;
end

function Powa_CompareDebufftypes(target, znum, z)
	_,_,_,_,typeDebuff = UnitAura(target, z, "HARMFUL");
	if (UnitAura(target, z, "HARMFUL")) then
		for pword in string.gmatch(PowaSet[znum].buffname, "[^/]+") do
			if (PowaSet[znum].ignoremaj == true) then
				if((typeDebuff == nil and string.find(string.upper(PowaSet[znum].buffname), string.upper(PowaText.aucun), 1, true))
				or (typeDebuff == "Magic" and string.find(string.upper(PowaSet[znum].buffname), string.upper(PowaText.TypeMagic), 1, true))
				or (typeDebuff == "Curse" and string.find(string.upper(PowaSet[znum].buffname), string.upper(PowaText.TypeCurse), 1, true))
				or (typeDebuff == "Disease" and string.find(string.upper(PowaSet[znum].buffname), string.upper(PowaText.TypeDisease), 1, true))
				or (typeDebuff == "Poison" and string.find(string.upper(PowaSet[znum].buffname), string.upper(PowaText.TypePoison), 1, true)) ) then
					Powa_CreateFrames(znum);
					Powa_Frames[znum].buffindex = z; --- point vers le debuff qui a le timer
					if (PowaSet[znum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture(UnitAura(target, z, "HARMFUL"));
						PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
					return true;
				end
			else
				if((typeDebuff == nil and string.find(PowaSet[znum].buffname, PowaText.aucun, 1, true))
				or (typeDebuff == "Magic" and string.find(PowaSet[znum].buffname, PowaText.TypeMagic, 1, true))
				or (typeDebuff == "Curse" and string.find(PowaSet[znum].buffname, PowaText.TypeCurse, 1, true))
				or (typeDebuff == "Disease" and string.find(PowaSet[znum].buffname, PowaText.TypeDisease, 1, true))
				or (typeDebuff == "Poison" and string.find(PowaSet[znum].buffname, PowaText.TypePoison, 1, true)) ) then
					Powa_CreateFrames(znum);
					Powa_Frames[znum].buffindex = z; --- point vers le debuff qui a le timer
					if (PowaSet[znum].icon == "") then
						getglobal("PowaIconTexture"):SetTexture(UnitAura(target, z, "HARMFUL"));
						PowaSet[znum].icon = getglobal("PowaIconTexture"):GetTexture();
					end --- icone
		      return true;
	      end
      end
		end
	end
	return false;
end	

function Powa_HideThisEffect(h)
	if (Powa_Frames[h] and Powa_Frames[h]:IsVisible() ) then
		Powa_FramesVisibleTime[h] = 0;
		if Powa_Frames[h].timerduree then
			Powa_Frames[h].timerduree = 0;
		end 
		if (h == CurrentSecondeAura) then
			Powa_FramesVisibleTime[SecondeAura] = 0;
			if (LastAura > 0) then --- cet effet n'est plus actif mais on affiche l'aura 2 sur le dernier effet
				CurrentSecondeAura = LastAura;
				Powa_DisplayAura(LastAura);
			end
		end
	end
end

function Powa_TestThisEffect(j)
	local numpm = GetNumPartyMembers();
	local numrm = GetNumRaidMembers();
	AuraHide = false;
	local bResult = true;

	PowaDebug("----------------------------------");
	PowaDebug("Test Aura for Hide or Show = "..j);
	
	--- player aura but player is dead
	if ((not PowaSet[j].target) 
  and (not PowaSet[j].targetfriend)
  and (not PowaSet[j].party)
	and (not PowaSet[j].raid) 
	and (not PowaSet[j].focus)
  and (not PowaSet[j].optunitn) 
  and (WeAreAlive == false)) then
  	bResult = false;
  end
	
	--- n'affiche pas si la cible est inexistante ou morte
	if ((PowaSet[j].target or PowaSet[j].targetfriend) and (UnitName("target") == nil or UnitIsDead("target") or UnitName("target") == UnitName("player")) ) then
		bResult = false;
	end
	    		
	--- regarde si la cible est ennemie
	if (PowaSet[j].target and PowaSet[j].targetfriend == false and UnitIsFriend("player","target")) then --- cible amie alors que faut pas
		bResult = false;
	end
		
	--- party
	if (PowaSet[j].party and not ((numpm > 0) or (numrm > 0))) then --- partycheck yes, but not in party
		bResult = false;
	end
        
    --- focus
	if (PowaSet[j].focus and (UnitName("focus") == nil or UnitIsDead("focus") or UnitName("focus") == UnitName("player"))) then --- focuscheck
		bResult = false;
	end
        
    --- unit
	if (PowaSet[j].optunitn and not ((numpm > 0) or (numrm > 0) or UnitExists("pet"))) then --- Unitn yes, but not in party/raid or with pet
		bResult = false;
	end
        
    --- raid
	if (PowaSet[j].raid and not (numrm > 0)) then --- raidcheck yes, but not in raid
		bResult = false;
	end
		
	--- regarde si la cible est amie
	if (PowaSet[j].target == false and PowaSet[j].targetfriend and not UnitIsFriend("player","target")) then --- cible ennemie
		bResult = false;
	end

	--- mode combat, cache si besoin
	if ((WeAreInCombat == true and PowaSet[j].combat == 2) or (WeAreInCombat == false and PowaSet[j].combat == 1)) then
		AuraHide = true;
		bResult = false;
	end
		
	if (WeAreInRaid == false and PowaSet[j].isinraid == true) then
		bResult = false;
	end
		
	if (WeAreMounted ~= PowaSet[j].ismounted) then	
		bResult = false;	
	end	

	if bResult == true then --- we passed the trivial checks...
		local bTemp = PowaCompareBuffDebuff(j); --- so check the trigger
		if PowaSet[j].inverse then
			bResult = (not bTemp) and PowaCheckMultiple(j);
		else
			bResult = bTemp and PowaCheckMultiple(j);
		end
	end
	
	if bResult == true then
		PowaDebug("ShowAura = "..PowaSet[j].buffname..": "..j);
	  Powa_DisplayAura(j);
	  LastAura = j;
	else
		PowaDebug("Buff Active - HideAura = "..j);
		Powa_HideThisEffect(j);
	end

end

function Powa_NewCheckBuffs()
     
	LastAura = 0;

	 --- test spell Alerts - start with these as they're short duration
	if ((DoCheckSpells or DoCheckMounted) and ListSpellsMax > 0 ) then
		for i = 1, ListSpellsMax do
			Powa_TestThisEffect(ListSpells[i]);
		end
		DoCheckSpells = false;
	end
	if ((DoCheckTargetSpells or DoCheckMounted) and ListTargetSpellsMax > 0 ) then
		for i = 1, ListTargetSpellsMax do
			Powa_TestThisEffect(ListTargetSpells[i]);
		end
		DoCheckTargetSpells = false;
	end
	if ((DoCheckFocusSpells or DoCheckMounted) and ListFocusSpellsMax > 0 ) then
		for i = 1, ListFocusSpellsMax do
			Powa_TestThisEffect(ListFocusSpells[i]);
		end
		DoCheckFocusSpells = false;
	end
     
  --- test buffs / debuffs / debuffs type du joueur
  if ((DoCheckBuffs or DoCheckMounted) and ListBuffsMax > 0) then
    --- DEFAULT_CHAT_FRAME:AddMessage("player");
    for i = 1, ListBuffsMax do
	    Powa_TestThisEffect(ListBuffs[i]);
    end
    DoCheckBuffs = false;
  end
     
  --- test party buffs / debuffs / debuffs type de la cible partie
  if ((DoCheckPartyBuffs or DoCheckMounted) and ListPartyBuffsMax > 0) then
    --- DEFAULT_CHAT_FRAME:AddMessage("party");
    for i = 1, ListPartyBuffsMax do
	    Powa_TestThisEffect(ListPartyBuffs[i]);
    end
    DoCheckPartyBuffs = false;
  end
    
  --- new raid de/buffs
  if ((DoCheckRaidBuffs or DoCheckMounted) and ListRaidBuffsMax > 0) then
    --- DEFAULT_CHAT_FRAME:AddMessage("raid");
    for i = 1, ListRaidBuffsMax do
	    Powa_TestThisEffect(ListRaidBuffs[i]);
    end
    DoCheckRaidBuffs = false;
  end
    
  --- newunit de/buffs
  if ((DoCheckUnitBuffs or DoCheckMounted) and ListUnitBuffsMax > 0) then
    for i = 1, ListUnitBuffsMax do
	    Powa_TestThisEffect(ListUnitBuffs[i]);
    end
    DoCheckUnitBuffs = false;
  end
     
  --- test buffs / debuffs / debuffs type de la cible target
  if ((DoCheckTargetBuffs or DoCheckMounted) and ListTargetBuffsMax > 0) then
      --- DEFAULT_CHAT_FRAME:AddMessage("target");
    for i = 1, ListTargetBuffsMax do
	    Powa_TestThisEffect(ListTargetBuffs[i]);
    end
    DoCheckTargetBuffs = false;
  end
    
  --- test buffs / debuffs / debuffs type de la cible focus
  if ((DoCheckFocusBuffs or DoCheckMounted) and ListFocusBuffsMax > 0) then
      --- DEFAULT_CHAT_FRAME:AddMessage("focus");
    for i = 1, ListFocusBuffsMax do
	    Powa_TestThisEffect(ListFocusBuffs[i]);
    end
    DoCheckFocusBuffs = false;
  end
     
  --- test les aoe
  if ((DoCheckAoe or DoCheckMounted) and ListAoeMax > 0) then
    for i = 1, ListAoeMax do
	  	Powa_TestThisEffect(ListAoe[i]);
    end
    DoCheckAoe = false;
    DoResetAoe = false;	
    AoeAuraAdded = "";
    AoeAuraFaded = "";
  end
     
  --- test les enchants et actions
  if ((DoCheckEnchant or DoCheckMounted)) then
    if (ListEnchantsMax > 0) then
	    for i = 1, ListEnchantsMax do
		  	Powa_TestThisEffect(ListEnchants[i]);
	    end
    end
    DoCheckEnchant = false;
  end
	
	--- test actions
  if ((DoCheckAction or DoCheckMounted) and ListActionsMax > 0) then
    for i = 1, ListActionsMax do
			Powa_TestThisEffect(ListActions[i]);
		end 
    DoCheckAction = false;
  end
     
  --- test les combos
  if ((DoCheckCombo or DoCheckMounted) and ListComboMax > 0) then
    for i = 1, ListComboMax do
	    Powa_TestThisEffect(ListCombo[i]);
    end
    DoCheckCombo = false;
  end
	
	--- test Health
  if ((DoCheckHealth or DoCheckMounted) and ListHealthMax > 0) then    
    for i = 1, ListHealthMax do
	    Powa_TestThisEffect(ListHealth[i]);
    end
    DoCheckHealth = false;
  end
     
  --- test party Health
  if ((DoCheckPartyHealth or DoCheckMounted) and ListPartyHealthMax > 0) then
    for i = 1, ListPartyHealthMax do
	    Powa_TestThisEffect(ListPartyHealth[i]);
    end
    DoCheckPartyHealth = false;
  end
    
  --- new raid Health
  if ((DoCheckRaidHealth or DoCheckMounted) and ListRaidHealthMax > 0) then
    for i = 1, ListRaidHealthMax do
	    Powa_TestThisEffect(ListRaidHealth[i]);
    end
    DoCheckRaidHealth = false;
  end
     
  --- test Health target
  if ((DoCheckTargetHealth or DoCheckMounted) and ListTargetHealthMax > 0) then
    for i = 1, ListTargetHealthMax do
	    Powa_TestThisEffect(ListTargetHealth[i]);
    end
    DoCheckTargetHealth = false;
  end
	
	--- test Health focus
  if ((DoCheckFocusHealth or DoCheckMounted) and ListFocusHealthMax > 0) then
    for i = 1, ListFocusHealthMax do
	    Powa_TestThisEffect(ListFocusHealth[i]);
    end
    DoCheckFocusHealth = false;
  end
	
	--- test Health unit
  if ((DoCheckUnitHealth or DoCheckMounted) and ListUnitHealthMax > 0) then
    for i = 1, ListUnitHealthMax do
	    Powa_TestThisEffect(ListUnitHealth[i]);
    end
    DoCheckUnitHealth = false;
  end
	
	--- test Mana
  if ((DoCheckMana or DoCheckMounted) and ListManaMax > 0) then
    for i = 1, ListManaMax do
	    Powa_TestThisEffect(ListMana[i]);
    end
    DoCheckMana = false;
  end
     
  --- test party Mana
  if ((DoCheckPartyMana or DoCheckMounted) and ListPartyManaMax > 0) then
    for i = 1, ListPartyManaMax do
	    Powa_TestThisEffect(ListPartyMana[i]);
    end
    DoCheckPartyMana = false;
  end
    
  --- new raid Mana
  if ((DoCheckRaidMana or DoCheckMounted) and ListRaidManaMax > 0) then
    for i = 1, ListRaidManaMax do
	    Powa_TestThisEffect(ListRaidMana[i]);
    end
    DoCheckRaidMana = false;
  end
     
  --- test Mana target
  if ((DoCheckTargetMana or DoCheckMounted) and ListTargetManaMax > 0) then
    for i = 1, ListTargetManaMax do
	    Powa_TestThisEffect(ListTargetMana[i]);
    end
    DoCheckTargetMana = false;
  end
	
	--- test Mana focus
  if ((DoCheckFocusMana or DoCheckMounted) and ListFocusManaMax > 0) then
    for i = 1, ListFocusManaMax do
	    Powa_TestThisEffect(ListFocusMana[i]);
    end	
    DoCheckFocusMana = false;
  end
	
	--- test Unit mana
  if ((DoCheckUnitMana or DoCheckMounted) and ListUnitManaMax > 0) then
    for i = 1, ListUnitManaMax do
	    Powa_TestThisEffect(ListUnitMana[i]);
    end
    DoCheckUnitMana = false;
  end
	
		--- test Rage/Energy/RunicPower
  if ((DoCheckRageEnergy or DoCheckMounted) and ListRageEnergyMax > 0) then
    for i = 1, ListRageEnergyMax do
	    Powa_TestThisEffect(ListRageEnergy[i]);
    end
    DoCheckRageEnergy = false;
  end
     
  --- test party Rage/Energy/RunicPower
  if ((DoCheckPartyRageEnergy or DoCheckMounted) and ListPartyRageEnergyMax > 0) then
    for i = 1, ListPartyRageEnergyMax do
	    Powa_TestThisEffect(ListPartyRageEnergy[i]);
    end
    DoCheckPartyRageEnergy = false;
  end
    
  --- new raid Rage/Energy/RunicPower
  if ((DoCheckRaidRageEnergy or DoCheckMounted) and ListRaidRageEnergyMax > 0) then
    for i = 1, ListRaidRageEnergyMax do
	    Powa_TestThisEffect(ListRaidRageEnergy[i]);
    end
    DoCheckRaidRageEnergy = false;
  end
     
  --- test Rage/Energy/RunicPower target
  if ((DoCheckTargetRageEnergy or DoCheckMounted) and ListTargetRageEnergyMax > 0) then
    for i = 1, ListTargetRageEnergyMax do
	    Powa_TestThisEffect(ListTargetRageEnergy[i]);
    end
    DoCheckTargetRageEnergy = false;
  end
	
	--- test Rage/Energy/RunicPower focus
  if ((DoCheckFocusRageEnergy or DoCheckMounted) and ListFocusRageEnergyMax > 0) then
    for i = 1, ListFocusRageEnergyMax do
	    Powa_TestThisEffect(ListFocusRageEnergy[i]);
    end	
    DoCheckFocusRageEnergy = false;
  end
	
		--- test Unit Rage/Energy/RunicPower
  if ((DoCheckUnitRageEnergy or DoCheckMounted) and ListUnitRageEnergyMax > 0) then
    for i = 1, ListUnitRageEnergyMax do
	    Powa_TestThisEffect(ListUnitRageEnergy[i]);
    end
    DoCheckUnitRageEnergy = false;
  end
	
	--- test aggro status
	if ((DoCheckAggro or DoCheckMounted) and ListAggroMax > 0 ) then
		for i = 1, ListAggroMax do
			Powa_TestThisEffect(ListAggro[i]);
		end
		DoCheckAggro = false;
	end
	if ((DoCheckPartyAggro or DoCheckMounted) and ListPartyAggroMax > 0 ) then
		for i = 1, ListPartyAggroMax do
			Powa_TestThisEffect(ListPartyAggro[i]);
		end
		DoCheckPartyAggro = false;
	end
	if ((DoCheckRaidAggro or DoCheckMounted) and ListRaidAggroMax > 0) then
		for i = 1, ListRaidAggroMax do
			Powa_TestThisEffect(ListRaidAggro[i]);
		end
		DoCheckRaidAggro = false;
	end
	
	--- test pvp Flag
	if ((DoCheckPvP or DoCheckMounted) and ListPvPMax > 0) then
		for i = 1, ListPvPMax do
			Powa_TestThisEffect(ListPvP[i]);
		end
		DoCheckPvP = false;
	end
	if ((DoCheckTargetPvP or DoCheckMounted) and ListTargetPvPMax > 0) then
		for i = 1, ListTargetPvPMax do
			Powa_TestThisEffect(ListTargetPvP[i]);
		end
		DoCheckTargetPvP = false;
	end
	if ((DoCheckPartyPvP or DoCheckMounted) and ListPartyPvPMax > 0) then
		for i = 1, ListPartyPvPMax do
			Powa_TestThisEffect(ListPartyPvP[i]);
		end
		DoCheckPartyPvP = false;
	end
	if ((DoCheckRaidPvP or DoCheckMounted) and ListRaidPvPMax > 0) then
		for i = 1, ListRaidPvPMax do
			Powa_TestThisEffect(ListRaidPvP[i]);
		end
		DoCheckRaidPvP = false;
	end
	
	 --- test stance
  if ((DoCheckStance or DoCheckMounted) and ListStanceMax > 0) then
    for i = 1, ListStanceMax do
	    Powa_TestThisEffect(ListStance[i]);
    end
    DoCheckStance = false;
  end
	DoCheckMounted = false;	
	
end

--- ---------------------------------------------------------------------------------------------------------

function Powa_MouseDown(self, button)
	if (button == "RightButton") then
		--- DEFAULT_CHAT_FRAME:AddMessage("RightMouseDown");
		RightClicking = true;
	end
end

function Powa_MouseUp(self, button)
	if (button == "RightButton") then
		--- DEFAULT_CHAT_FRAME:AddMessage("RightMouseUp");
		RightClicking = false;
	end
end

--- -----------------------------------------------------------------------------------------------------------

function Powa_DisplayAura(FNum)
	local TexDeca = 0.0;
	local FRandom = 0;
	local pitch, yaw, squish
	
	if (PowaEnabled == 0) then return; end   --- desactived

	if (Powa_FramesVisibleTime[FNum] == 0) then  --- si pas en cours
		if (PowaModTest == false) then
			if (PowaSet[FNum].sound > 0) and (PowaSet[FNum].customsound == "") then
				PlaySound(PowaSet[FNum].soundfile);
			end	
			if not (PowaSet[FNum].customsound == "") then
				PlaySoundFile("Interface\\AddOns\\PowerAuras\\Sounds\\"..PowaSet[FNum].customsound);
			end	
		end
		Powa_CreateFrames(FNum); --- cree la frame si pas encore creee
	
		if (PowaSet[FNum].owntex == true) then
	  	Powa_textures[FNum]:SetTexture(PowaSet[FNum].icon);
	  elseif (PowaSet[FNum].wowtex == true) then
	    Powa_textures[FNum]:SetTexture(PowaWowTextures[PowaSet[FNum].texture]);
	  elseif (PowaSet[FNum].customtex == true) then
	    Powa_textures[FNum]:SetTexture(PowaCustomTexPath(PowaSet[FNum].customname));
	  elseif (PowaSet[FNum].textaura == true) then
			Powa_textures[FNum]:SetText(PowaSet[FNum].aurastext);	  	
	  else
	    Powa_textures[FNum]:SetTexture("Interface\\Addons\\PowerAuras\\Auras\\Aura"..PowaSet[FNum].texture..".tga");
	  end
	  
	  if (PowaSet[FNum].randomcolor) then
    	Powa_textures[FNum]:SetVertexColor(random(20,100)/100,random(20,100)/100,random(20,100)/100);	
	  else
    	Powa_textures[FNum]:SetVertexColor(PowaSet[FNum].r,PowaSet[FNum].g,PowaSet[FNum].b);
	  end
	  
	  if (PowaSet[FNum].texmode == 1) then
	  	if not (PowaSet[FNum].textaura == true) then
	    	Powa_textures[FNum]:SetBlendMode("ADD");
	    else
	    	Powa_textures[FNum]:SetShadowColor(0.0, 0.0, 0.0, 0.8);
	    	Powa_textures[FNum]:SetShadowOffset(2,-2);
	    end
	    Powa_Frames[FNum]:SetFrameStrata("LOW");
	  else
	  	if not (PowaSet[FNum].textaura == true) then
	    	Powa_textures[FNum]:SetBlendMode("DISABLE");
	    else
	    	Powa_textures[FNum]:SetShadowColor(0.0, 0.0, 0.0, 0.0);
	    	Powa_textures[FNum]:SetShadowOffset(0,0);
	    end
	    Powa_Frames[FNum]:SetFrameStrata("BACKGROUND");
	  end

	  if not (PowaSet[FNum].textaura == true) then
		  if (PowaSet[FNum].symetrie == 1) then 
		  	Powa_textures[FNum]:SetTexCoord(1, 0, 0, 1); --- inverse X
		  elseif (PowaSet[FNum].symetrie == 2) then 
		  	Powa_textures[FNum]:SetTexCoord(0, 1, 1, 0); --- inverse Y
		  elseif (PowaSet[FNum].symetrie == 3) then 
		  	Powa_textures[FNum]:SetTexCoord(1, 0, 1, 0); --- inverse XY
		  else 
		  	Powa_textures[FNum]:SetTexCoord(0, 1, 0, 1); 
		  end	
	  end

	  if (PowaSet[FNum].begin > 0) then 
	  	Powa_Frames[FNum].beginAnim = 1;
	  else 
	  	Powa_Frames[FNum].beginAnim = 0; 
	 	end
 
    Powa_Frames[FNum].baseL = 256 * PowaSet[FNum].size * PowaSet[FNum].torsion;
	  Powa_Frames[FNum].baseH = 256 * PowaSet[FNum].size * (2-PowaSet[FNum].torsion);
    if (PowaSet[FNum].textaura == true) then
    	local fontsize = math.min(33, math.max(10, math.floor(Powa_Frames[FNum].baseH / 12.8)));
    	local checkfont = Powa_textures[FNum]:SetFont(PowaFonts[PowaSet[FNum].aurastextfont], fontsize, "OUTLINE, MONOCHROME");
    	if not checkfont then
    		Powa_textures[FNum]:SetFont(STANDARD_TEXT_FONT, fontsize, "OUTLINE, MONOCHROME");
   		end
    	Powa_Frames[FNum].baseL = Powa_textures[FNum]:GetStringWidth() + 5;
    end
    
    --- end       
    Powa_Frames[FNum]:SetAlpha(PowaSet[FNum].alpha);
    Powa_Frames[FNum]:SetPoint("Center",PowaSet[FNum].x, PowaSet[FNum].y);
    Powa_Frames[FNum]:SetWidth(Powa_Frames[FNum].baseL);
    Powa_Frames[FNum]:SetHeight(Powa_Frames[FNum].baseH);
    Powa_Frames[FNum].statut = 0;
    Powa_Frames[FNum].duree = 0;
    Powa_Frames[FNum].timerduree = PowaSet[FNum].timerduration;
    Powa_Frames[FNum]:Show();

    Powa_FramesVisibleTime[FNum] = 1;        --- affiche anim1
    Powa_FramesVisibleTime[SecondeAura] = 0; --- init anim2
	end

	if (Powa_FramesVisibleTime[SecondeAura] == 0) then  --- si pas en cours (Anim 2)
		CurrentSecondeAura = FNum; --- 2eme aura en cours
	
		if (PowaSet[FNum].anim2 == 0) then --- pas d'anim
			Powa_Frames[SecondeAura]:Hide();
			return;
		end

		if (PowaSet[FNum].begin > 0) then 
			Powa_Frames[SecondeAura].beginAnim = 2;
		else 
			Powa_Frames[SecondeAura].beginAnim = 0; 
		end

		PowaSet[SecondeAura].size = PowaSet[FNum].size;
		PowaSet[SecondeAura].torsion = PowaSet[FNum].torsion;
		PowaSet[SecondeAura].symetrie = PowaSet[FNum].symetrie;
		PowaSet[SecondeAura].alpha = PowaSet[FNum].alpha * 0.5;
		PowaSet[SecondeAura].anim1 = PowaSet[FNum].anim2;
		PowaSet[SecondeAura].speed = PowaSet[FNum].speed - 0.1; --- legerement plus lent
		PowaSet[SecondeAura].duration = PowaSet[FNum].duration;
		PowaSet[SecondeAura].begin = PowaSet[FNum].begin;
		PowaSet[SecondeAura].finish = PowaSet[FNum].finish;
		PowaSet[SecondeAura].x = PowaSet[FNum].x;
		PowaSet[SecondeAura].y = PowaSet[FNum].y;

		if (PowaSet[FNum].wowtex == true) then
			Powa_textures[SecondeAura]:SetTexture(PowaWowTextures[PowaSet[FNum].texture]);
		elseif (PowaSet[FNum].customtex == true) then
			Powa_textures[SecondeAura]:SetTexture(PowaCustomTexPath(PowaSet[FNum].customname));
		elseif (PowaSet[FNum].textaura == true) then
			Powa_textures[SecondeAura]:SetTexture(nil);
		else
			Powa_textures[SecondeAura]:SetTexture("Interface\\Addons\\PowerAuras\\Auras\\Aura"..PowaSet[FNum].texture..".tga");
		end
		if (PowaSet[FNum].randomcolor) then
			if Powa_textures[FNum]:GetObjectType() == "Texture" then
				Powa_textures[SecondeAura]:SetVertexColor( Powa_textures[FNum]:GetVertexColor() );
			elseif Powa_textures[FNum]:GetObjectType() == "FontString" then
				Powa_textures[SecondeAura]:SetVertexColor(Powa_textures[FNum]:GetTextColor());
			end
		else
			Powa_textures[SecondeAura]:SetVertexColor(PowaSet[FNum].r,PowaSet[FNum].g,PowaSet[FNum].b);
		end
		if (PowaSet[FNum].texmode == 1) then
			if PowaSet[FNum].textaura == true then
				Powa_textures[SecondeAura]:SetBlendMode("ADD");
			end
			Powa_Frames[SecondeAura]:SetFrameStrata("LOW");
		else
			if PowaSet[FNum].textaura == true then
				Powa_textures[SecondeAura]:SetBlendMode("DISABLE");
			end
			Powa_Frames[SecondeAura]:SetFrameStrata("BACKGROUND");
		end
    
    if not PowaSet[FNum].textaura == true then
			if (PowaSet[FNum].symetrie == 1) then 
				Powa_textures[SecondeAura]:SetTexCoord(1, 0, 0, 1); --- inverse X
			elseif (PowaSet[FNum].symetrie == 2) then 
				Powa_textures[SecondeAura]:SetTexCoord(0, 1, 1, 0); --- inverse Y
			elseif (PowaSet[FNum].symetrie == 3) then 
				Powa_textures[SecondeAura]:SetTexCoord(1, 0, 1, 0); --- inverse XY
			else 
				Powa_textures[SecondeAura]:SetTexCoord(0, 1, 0, 1); 
			end
    end
    
		Powa_Frames[SecondeAura].baseL = Powa_Frames[FNum].baseL;
		Powa_Frames[SecondeAura].baseH = Powa_Frames[FNum].baseH;
		Powa_Frames[SecondeAura]:SetAlpha(PowaSet[SecondeAura].alpha);
		Powa_Frames[SecondeAura]:SetPoint("Center",PowaSet[FNum].x, PowaSet[FNum].y);
		Powa_Frames[SecondeAura]:SetWidth(Powa_Frames[SecondeAura].baseL);
		Powa_Frames[SecondeAura]:SetHeight(Powa_Frames[SecondeAura].baseH);
		Powa_Frames[SecondeAura].statut = 1;
		Powa_Frames[SecondeAura].duree = Powa_Frames[FNum].duree;
		Powa_Frames[SecondeAura].timerduree = Powa_Frames[FNum].timerduree;
    
    --- si on doit reafficher une seconde anim, fait gaffe de pas la reafficher si elle est sensee avoir disparu
    if (PowaSet[SecondeAura].duration > 0 and Powa_Frames[SecondeAura].duree > PowaSet[SecondeAura].duration) then 
    	return; 
    end

    Powa_Frames[SecondeAura]:Show();
    Powa_FramesVisibleTime[SecondeAura] = 1;
    
	end
end

--- ------------------------------------------------------------------------------------------------- ON UPDATE
minScale = {a=0, w=0, h=0};
maxScale = {a=0, w=0, h=0};
curScale = {a=0, w=0, h=0};
speedScale = 0;

function Powa_OnUpdate(self, elapsed)
    
	--- lance les checks de la cible
	ChecksTimer = ChecksTimer + elapsed;
  local pitch, yaw, squish

	if (ChecksTimer > NextCheck) then
		ChecksTimer = 0;
		if (PowaModTest == false) then
			if IsMounted() or IsFlying() then
				WeAreMountednew = true;
			else
				WeAreMountednew = false;
			end
			if (WeAreMountednew ~= WeAreMounted) then
				DoCheckMounted = true;
				WeAreMounted = WeAreMountednew;
			end	
			DoCheckEnchant = true;
		end
	end  

	--- Usable pending Checks
	if UsablePending then
		for slot, cd in pairs(UsablePending) do	
			if cd then
				if GetTime() > cd then
					if (PowaModTest == false) then
						DoCheckAction = true;
						DoCheckStance = true;
						if IsMounted() or IsFlying() then
							WeAreMounted = true;
						else
							WeAreMounted = false;
						end
						UsablePending[slot] = nil;
					end
				end
			end
		end
	end
	
	--- lance les checks normaux
	if (DoCheckBuffs
	or DoCheckTargetBuffs 
	or DoCheckPartyBuffs 
	or DoCheckRaidBuffs 
	or DoCheckUnitBuffs 
	or DoCheckFocusBuffs 
	or DoCheckHealth
	or DoCheckTargetHealth
	or DoCheckPartyHealth 
	or DoCheckRaidHealth 
	or DoCheckFocusHealth 
	or DoCheckMana
	or DoCheckTargetMana
	or DoCheckPartyMana 
	or DoCheckRaidMana 
	or DoCheckFocusMana
	or DoCheckRageEnergy
	or DoCheckTargetRageEnergy
	or DoCheckPartyRageEnergy 
	or DoCheckRaidRageEnergy 
	or DoCheckFocusRageEnergy
	or DoCheckStance
	or DoCheckAction
	or DoCheckEnchant
	or DoCheckMounted
	or DoCheckPvP
 	or DoCheckPartyPvP
	or DoCheckRaidPvP
	or DoCheckTargetPvP
	or DoCheckAggro
	or DoCheckPartyAggro
	or DoCheckRaidAggro
	or DoCheckSpells
	or DoCheckTargetSpells
	or DoCheckFocusSpells) then
	  Powa_NewCheckBuffs();  
	end

  for i = 0, MaxAuras do
  	if (PowaEnabled == 0) then return end --- desactived
  	
		if (PowaSet[i] == nil or Powa_Frames[i] == nil) then
		--- rien si vide
         	 
		elseif (Powa_FramesVisibleTime[i] > 0) then --- si visible seulement
    	Powa_UpdateTimer(i);
		 	--- met a jour les Timers
			DebugTimer = DebugTimer + 1; --- debug

			curScale.w = Powa_Frames[i].baseL; --- regle la taille de l'image en pixel
			curScale.h = Powa_Frames[i].baseH;

			--- pas d'anim si l'effet va disparaitre avec duree
			if ((PowaSet[i].duration > 0) and (Powa_Frames[i].duree > PowaSet[i].duration)) then
				--- si visible, baisse l'alpha
				if (Powa_Frames[i]:GetAlpha() > 0) then
					Powa_Frames[i].beginAnim = 0;
					curScale.a = Powa_Frames[i]:GetAlpha() - (elapsed * 2);
					--- si alpha 0, cache
					if (curScale.a <= 0) then
						Powa_Frames[i]:SetAlpha(0);
					else
						Powa_Frames[i]:SetAlpha(curScale.a);
					end
				end
			--- animation de depart active ----------------------------------------------------
			elseif (Powa_Frames[i].beginAnim > 0) then
				if (i == SecondeAura) then --- la 2eme aura ne s'affiche pas maintenant
					if (Powa_Frames[CurrentSecondeAura].beginAnim == 0) then --- la premiere a fini
						Powa_Frames[i].beginAnim = 0;
						Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
					else
						Powa_Frames[i]:SetAlpha(0.0);
					end
				elseif (PowaSet[i].begin == 1) then --- zoom avant
					maxScale.w = curScale.w * 1.5;
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i]:SetWidth(maxScale.w);
						Powa_Frames[i]:SetHeight(curScale.h * 1.5);
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() - (elapsed * 150 * PowaSet[i].speed * PowaSet[i].torsion) );
					Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() - (elapsed * 150 * PowaSet[i].speed * (2-PowaSet[i].torsion)) );
					Powa_Frames[i]:SetAlpha( ((maxScale.w - Powa_Frames[i]:GetWidth()) / (maxScale.w - curScale.w)) * PowaSet[i].alpha );
					if (Powa_Frames[i]:GetWidth() < curScale.w) then
						Powa_Frames[i]:SetWidth(curScale.w);
						Powa_Frames[i]:SetHeight(curScale.h);
						Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
						Powa_Frames[i].beginAnim = 0;
					end
				elseif (PowaSet[i].begin == 2) then --- zoom arriere
					maxScale.w = curScale.w * 0.5;
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i]:SetWidth(maxScale.w);
						Powa_Frames[i]:SetHeight(curScale.h * 0.5);
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() + (elapsed * 150 * PowaSet[i].speed * PowaSet[i].torsion) );
					Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() + (elapsed * 150 * PowaSet[i].speed * (2-PowaSet[i].torsion)) );
					Powa_Frames[i]:SetAlpha( ((maxScale.w - Powa_Frames[i]:GetWidth()) / (maxScale.w - curScale.w)) * PowaSet[i].alpha );
					if (Powa_Frames[i]:GetWidth() > curScale.w) then
						Powa_Frames[i]:SetWidth(curScale.w);
						Powa_Frames[i]:SetHeight(curScale.h);
						Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
						Powa_Frames[i].beginAnim = 0;
					end
				elseif (PowaSet[i].begin == 3) then --- transparence
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 2 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i]:GetAlpha() > PowaSet[i].alpha) then
						Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
						Powa_Frames[i].beginAnim = 0;
					end
				elseif (PowaSet[i].begin == 4) then --- gauche
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x - 100;
						Powa_Frames[i].beginAnimY = PowaSet[i].y;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX + (elapsed * 200 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 2 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX > PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 5) then
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x - 75;
						Powa_Frames[i].beginAnimY = PowaSet[i].y + 75;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX + (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY - (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 1.5 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX > PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 6) then --- haut
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x;
						Powa_Frames[i].beginAnimY = PowaSet[i].y + 100;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY - (elapsed * 200 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 2 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimY < PowaSet[i].y) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 7) then
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x + 75;
						Powa_Frames[i].beginAnimY = PowaSet[i].y + 75;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX - (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY - (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 1.5 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX < PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 8) then --- droite
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x + 100;
						Powa_Frames[i].beginAnimY = PowaSet[i].y;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX - (elapsed * 200 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 2 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX < PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 9) then
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x + 75;
						Powa_Frames[i].beginAnimY = PowaSet[i].y - 75;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX - (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY + (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 1.5 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX < PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 10) then --- haut
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x;
						Powa_Frames[i].beginAnimY = PowaSet[i].y - 100;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY + (elapsed * 200 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 2 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimY > PowaSet[i].y) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				elseif (PowaSet[i].begin == 11) then
					if (Powa_Frames[i].beginAnim == 1) then --- init
						Powa_Frames[i].beginAnimX = PowaSet[i].x - 75;
						Powa_Frames[i].beginAnimY = PowaSet[i].y - 75;
						Powa_Frames[i].beginAnim = 3;
						Powa_Frames[i]:SetAlpha(0.0);
					end
					Powa_Frames[i].beginAnimX = Powa_Frames[i].beginAnimX + (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i].beginAnimY = Powa_Frames[i].beginAnimY + (elapsed * 150 * PowaSet[i].speed);
					Powa_Frames[i]:SetAlpha( Powa_Frames[i]:GetAlpha() + (elapsed * 1.5 * PowaSet[i].speed * PowaSet[i].alpha) );
					if (Powa_Frames[i].beginAnimX > PowaSet[i].x) then
						Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
						Powa_Frames[i].beginAnim = 0;
					else
						Powa_Frames[i]:SetPoint("Center",Powa_Frames[i].beginAnimX, Powa_Frames[i].beginAnimY);
					end
				end
		--- Animations ----------------------------------------------------------------------
		--- Animation 1 : aucune
		elseif (PowaSet[i].anim1 == 1) then

		--- Animation 2 : max alpha <-> mi-alpha
		elseif (PowaSet[i].anim1 == 2) then
			minScale.a = PowaSet[i].alpha * 0.5 * PowaSet[i].speed;
			maxScale.a = PowaSet[i].alpha;

			if (Powa_Frames[i].statut == 0) then
				curScale.a = Powa_Frames[i]:GetAlpha() - (elapsed / 2);
				Powa_Frames[i]:SetAlpha( curScale.a )
				if (Powa_Frames[i]:GetAlpha() < minScale.a) then
					Powa_Frames[i]:SetAlpha(minScale.a);
					Powa_Frames[i].statut = 1;
				end
			else
				curScale.a = Powa_Frames[i]:GetAlpha() + (elapsed / 2);
				if (curScale.a > 1.0) then curScale.a = 1.0; end --- pas trop haut non plus
				Powa_Frames[i]:SetAlpha( curScale.a )
				if (Powa_Frames[i]:GetAlpha() >= maxScale.a) then 
					Powa_Frames[i]:SetAlpha(maxScale.a);
					Powa_Frames[i].statut = 0;
				end
			end
		--- Animation 3 : mini-zoom in repetitif + fading
		elseif (PowaSet[i].anim1 == 3) then
			minScale.w = curScale.w * 0.90;
			minScale.h = curScale.h * 0.90;
			maxScale.w = curScale.w * 1.20;
			maxScale.h = curScale.h * 1.20;
			speedScale = (25 * PowaSet[i].speed) * PowaSet[i].size;

			if (Powa_Frames[i].statut == 1) then  --- decale anim 2
				Powa_Frames[i]:SetWidth(curScale.w * 1.15);
				Powa_Frames[i]:SetHeight(curScale.h * 1.15);
				Powa_Frames[i].statut = 0;
			end

			Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() + (elapsed * speedScale) )
			Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() + (elapsed * speedScale) )

			Powa_Frames[i]:SetAlpha( ((maxScale.w - Powa_Frames[i]:GetWidth()) / (maxScale.w - minScale.w)) * PowaSet[i].alpha );

			if (Powa_Frames[i]:GetWidth() > maxScale.w) then
				Powa_Frames[i]:SetWidth(minScale.w);
				Powa_Frames[i]:SetHeight(minScale.h);
			end
		--- Animation 4 : mini-zoom in/out
		elseif (PowaSet[i].anim1 == 4) then
			minScale.w = curScale.w * 0.95;
			minScale.h = curScale.h * 0.95;
			maxScale.w = curScale.w * 1.05;
			maxScale.h = curScale.h * 1.05;
			speedScale = (50 * PowaSet[i].speed) * PowaSet[i].size;

			if (Powa_Frames[i].statut == 0) then
				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() + (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() + (elapsed * speedScale * (2-PowaSet[i].torsion) ) )				
				if (Powa_Frames[i]:GetWidth() > maxScale.w) then	
					Powa_Frames[i]:SetWidth(maxScale.w);
					Powa_Frames[i]:SetHeight(maxScale.h);
					Powa_Frames[i].statut = 1;
				end
			else
				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() - (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() - (elapsed * speedScale * (2-PowaSet[i].torsion) ) )				
				if (Powa_Frames[i]:GetWidth() < minScale.w) then 
					Powa_Frames[i]:SetWidth(minScale.w);
					Powa_Frames[i]:SetHeight(minScale.h);
					Powa_Frames[i].statut = 0;
				end
			end
		--- Animation 5 : effet bulle
		elseif (PowaSet[i].anim1 == 5) then
			minScale.w = curScale.w * 0.95;
			minScale.h = curScale.h * 0.95;
			maxScale.w = curScale.w * 1.05;
			maxScale.h = curScale.h * 1.05;
			speedScale = (50 * PowaSet[i].speed) * PowaSet[i].size;

			if (Powa_Frames[i].statut == 0) then	
				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() + (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() - (elapsed * speedScale * (2-PowaSet[i].torsion) ) )
				if (Powa_Frames[i]:GetWidth() > maxScale.w) then
					Powa_Frames[i]:SetWidth(maxScale.w);
					Powa_Frames[i]:SetHeight(minScale.h);
					Powa_Frames[i].statut = 1;
				end
			else
				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() - (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() + (elapsed * speedScale * (2-PowaSet[i].torsion) ) )
				if (Powa_Frames[i]:GetHeight() > maxScale.h) then 
					Powa_Frames[i]:SetWidth(minScale.w);
					Powa_Frames[i]:SetHeight(maxScale.h);
					Powa_Frames[i].statut = 0;
				end
			end
		--- position au hasard + zoom in + fade
		elseif (PowaSet[i].anim1 == 6) then
			if (Powa_Frames[i]:GetAlpha() > 0) then
				curScale.a = Powa_Frames[i]:GetAlpha() - (elapsed * PowaSet[i].alpha * 0.5 * PowaSet[i].speed);
				if (curScale.a < 0) then Powa_Frames[i]:SetAlpha(0.0);
				else Powa_Frames[i]:SetAlpha(curScale.a); end
				maxScale.w = Powa_Frames[i]:GetWidth() + (elapsed * 100 * PowaSet[i].speed * PowaSet[i].size);
				maxScale.h = Powa_Frames[i]:GetHeight() + (elapsed * 100 * PowaSet[i].speed * PowaSet[i].size);
				if ( (maxScale.w * 1.5) > Powa_Frames[i]:GetWidth()) then --- evite les lags
					Powa_Frames[i]:SetWidth(maxScale.w)
					Powa_Frames[i]:SetHeight(maxScale.h)
				end
			else
				maxScale.w = (random(0,20) - 10) * PowaSet[i].speed;
				maxScale.h = (random(0,20) - 10) * PowaSet[i].speed;
				Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
				Powa_Frames[i]:SetWidth(curScale.w * 0.85);
				Powa_Frames[i]:SetHeight(curScale.h * 0.85);
				Powa_Frames[i]:SetPoint("Center",PowaSet[i].x + maxScale.w, PowaSet[i].y + maxScale.h);
			end
		--- static sauf parfois ou la texture est decalee + opaque (type electrique)
		elseif (PowaSet[i].anim1 == 7) then
			if (Powa_Frames[i].statut < 2) then
				Powa_Frames[i]:SetAlpha(PowaSet[i].alpha / 2); --- mi-alpha
				if (random( 210-(PowaSet[i].speed*100) ) == 1) then
					Powa_Frames[i].statut = 2;
					maxScale.w = random(0,10) - 5;
					maxScale.h = random(0,10) - 5;
					Powa_Frames[i]:SetPoint("Center",PowaSet[i].x + maxScale.w, PowaSet[i].y + maxScale.h);
					Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
				end
			else
				Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
				Powa_Frames[i].statut = 0;
			end
		--- zoom out + stop + fade
		elseif (PowaSet[i].anim1 == 8) then
			minScale.w = curScale.w;
			minScale.h = curScale.h;
			maxScale.w = curScale.w * 1.30;
			maxScale.h = curScale.h * 1.30;
			speedScale = (50 * PowaSet[i].speed) * PowaSet[i].size;
			
			if (Powa_Frames[i].statut == 0) then --- demarre le zoom out (max size)
				Powa_Frames[i]:SetWidth(maxScale.w);
				Powa_Frames[i]:SetHeight(maxScale.h);
				Powa_Frames[i]:SetAlpha(0.0);
				Powa_Frames[i].statut = 2;
			elseif (Powa_Frames[i].statut == 2) then --- zoom out + fade in
				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() - (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() - (elapsed * speedScale * (2-PowaSet[i].torsion) ) )

				Powa_Frames[i]:SetAlpha( ((maxScale.w - Powa_Frames[i]:GetWidth()) / (maxScale.w - minScale.w)) * PowaSet[i].alpha );

				if (Powa_Frames[i]:GetWidth() < curScale.w) then
					Powa_Frames[i]:SetWidth(curScale.w);
					Powa_Frames[i]:SetHeight(curScale.h);	
					Powa_Frames[i].statut = 1;
				end
			elseif (Powa_Frames[i].statut == 1) then --- demarre le fade-out
				Powa_Frames[i]:SetWidth(curScale.w);
				Powa_Frames[i]:SetHeight(curScale.h);
				Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
				Powa_Frames[i].statut = 3;

			elseif (Powa_Frames[i].statut == 3) then --- fade-out
				curScale.a = Powa_Frames[i]:GetAlpha() - (elapsed / random(1,2));

				if (curScale.a < 0.0) then
					Powa_Frames[i]:SetAlpha(0.0);
					Powa_Frames[i].statut = 0;
				else
					Powa_Frames[i]:SetAlpha(curScale.a);
				end
			end
		--- deplacement vers le haut + fade-out + reduction
		elseif (PowaSet[i].anim1 == 9) then
			speedScale = (50 * PowaSet[i].speed) * PowaSet[i].size;
			
			if (Powa_Frames[i].statut < 2) then --- debut
				Powa_Frames[i]:SetWidth(curScale.w);
				Powa_Frames[i]:SetHeight(curScale.h);
				Powa_Frames[i]:SetPoint("Center",PowaSet[i].x, PowaSet[i].y);
				Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
				Powa_Frames[i].statut = 2;
			else
				_,_,_,xOfs,yOfs = Powa_Frames[i]:GetPoint();
				Powa_Frames[i]:SetPoint("Center",xOfs + (random(1,3)-2), yOfs + (elapsed * random(10,20)));
				curScale.a = Powa_Frames[i]:GetAlpha() - ( (elapsed / random(2,4)) * PowaSet[i].alpha);

				Powa_Frames[i]:SetWidth( Powa_Frames[i]:GetWidth() - (elapsed * speedScale * PowaSet[i].torsion) )
				Powa_Frames[i]:SetHeight( Powa_Frames[i]:GetHeight() - (elapsed * speedScale * (2-PowaSet[i].torsion) ) )

				if (curScale.a < 0.0) then
					Powa_Frames[i]:SetAlpha(0.0);
					Powa_Frames[i].statut = 1;
				else
					Powa_Frames[i]:SetAlpha(curScale.a);
				end
			end
		--- rotation autour du centre
		elseif (PowaSet[i].anim1 == 10) then
			maxScale.w = math.max(PowaSet[i].x, -PowaSet[i].x, 5) * 1.0;
			maxScale.h = maxScale.w * (1.6 - PowaSet[i].torsion);
			speedScale = elapsed * 75 * PowaSet[i].speed;
			
			if ((i == SecondeAura) and (PowaSet[CurrentSecondeAura].anim1 == 10)) then
				if (PowaSet[i].symetrie < 2) then
					Powa_Frames[i].statut = Powa_Frames[CurrentSecondeAura].statut + 180;
					if (Powa_Frames[i].statut > 360) then Powa_Frames[i].statut = Powa_Frames[i].statut - 360; end
				else
					Powa_Frames[i].statut = 180-Powa_Frames[CurrentSecondeAura].statut;
					if (Powa_Frames[i].statut < 0) then Powa_Frames[i].statut = Powa_Frames[i].statut + 360; end
				end
			elseif (PowaSet[i].symetrie == 1 or PowaSet[i].symetrie == 3) then
				Powa_Frames[i].statut = Powa_Frames[i].statut - speedScale;
				if (Powa_Frames[i].statut < 0) then Powa_Frames[i].statut = 360; end
			else
				Powa_Frames[i].statut = Powa_Frames[i].statut + speedScale;
				if (Powa_Frames[i].statut > 360) then Powa_Frames[i].statut = 0; end
			end

			--- annule la torsion
			Powa_Frames[i]:SetWidth(curScale.w / PowaSet[i].torsion);
			Powa_Frames[i]:SetHeight(curScale.h / (2-PowaSet[i].torsion));
			--- annule la symetrie
			if not PowaSet[i].textaura == true then
				Powa_textures[i]:SetTexCoord(0, 1, 0, 1);
			end

			--- transparence
			if (Powa_Frames[i].statut < 180) then --- zone de transparence
				if (Powa_Frames[i].statut < 90) then
					Powa_Frames[i]:SetAlpha( (1-(Powa_Frames[i].statut / 90)) * PowaSet[i].alpha );
				else
					Powa_Frames[i]:SetAlpha( ((Powa_Frames[i].statut-90) / 90) * PowaSet[i].alpha );
				end
			else
				Powa_Frames[i]:SetAlpha(PowaSet[i].alpha);
			end

			Powa_Frames[i]:SetPoint("Center",maxScale.w * cos(Powa_Frames[i].statut), (maxScale.h * sin(Powa_Frames[i].statut)) + PowaSet[i].y);
		end

		--- si duration
		if (PowaSet[i].duration > 0) then
			--- ajoute le temps passe
			Powa_Frames[i].duree = Powa_Frames[i].duree + elapsed;
		end
		--- si timer duration
		if (PowaSet[i].timerduration > 0) then
			--- diminue le temps
			Powa_Frames[i].timerduree = Powa_Frames[i].timerduree - elapsed;
			if (Powa_Frames[i].timerduree < 0) then Powa_Frames[i].timerduree = 0; end;
		end

	--- FADE OUT
	elseif Powa_Frames[i]:IsVisible() then

	    if (PowaSet[i].finish > 0) then
		curScale.a = Powa_Frames[i]:GetAlpha() - (elapsed * 2);

		if (curScale.a <= 0) then
			Powa_Frames[i]:Hide();
		else
			if (PowaSet[i].finish == 1) then --- agrandir + fade
				Powa_Frames[i]:SetWidth(Powa_Frames[i]:GetWidth() + (elapsed * 200) );
				Powa_Frames[i]:SetHeight(Powa_Frames[i]:GetHeight() + (elapsed * 200) );
			elseif (PowaSet[i].finish == 2) then --- retrecir + fade
				Powa_Frames[i]:SetWidth( math.max(0, Powa_Frames[i]:GetWidth() - (elapsed * 200)) );
				Powa_Frames[i]:SetHeight( math.max(0, Powa_Frames[i]:GetHeight() - (elapsed * 200)) );
			end
			Powa_Frames[i]:SetAlpha(curScale.a);
		end
	    else
		Powa_Frames[i]:Hide();
	    end	
	
	elseif (PowaSet[i].bufftype == 7)then 
		Powa_UpdateTimer(i);
	end
	

  end	
	Powa_ResetTimers(); --- reset Timers
  ResetTargetTimers = false;
  DebugTimer = 0;

end

--- ------------------------------------------------------------------------------------------------- TIMERS
function Powa_UpdateTimer(numi)
	if (numi > MaxAuras) then --- fin du cycle on arrete
		return;
	elseif (PowaSet[numi] == nil) then --- aucun effet
		return;
	elseif (PowaSet[numi].timer == false) then --- cet effet n'affiche pas de timer
		return;
	end
	
	local newvalue, ntimer, unitidentifikation, lastvalue, bemine;
	
---	ntimer = PowaSet[numi].numtimer;
	ntimer = numi;
	bemine = PowaSet[numi].mine;
	
	
	if (PowaSet[numi].target or PowaSet[numi].targetfriend) then
		unitidentifikation = "target";
	elseif (PowaSet[numi].focus) then
		unitidentifikation = "focus";
	elseif (PowaSet[numi].party) then
		unitidentifikation = "party";
	elseif (PowaSet[numi].raid) then
		unitidentifikation = "raid";
	elseif (PowaSet[numi].optunitn) then
		unitidentifikation = PowaSet[numi].unitn;
	else
		unitidentifikation = "player";
	end
	
	local numpm = GetNumPartyMembers();
  local numrm = GetNumRaidMembers();

	--- si on test, met des valeur de timer au hasard...
	if (PowaModTest) then
		newvalue = random(1,9) + (random(1, 99) / 100);
	
	--- if a user defined timer is active for the aura override the rest
	elseif (PowaSet[numi].timerduration > 0) then
		if (PowaSet[numi].target or PowaSet[numi].targetfriend) and (ResetTargetTimers == true) then
			Powa_Frames[numi].timerduree = 0;
			newvalue = 0;
		else
			newvalue = Powa_Frames[numi].timerduree;
		end	
	
	--- if spell alert take the end channel or end cast time (saved in buffindex)
	elseif (PowaSet[numi].bufftype == 13) then
		if Powa_Frames[numi].buffindex > 0 then
			newvalue = Powa_Frames[numi].buffindex - GetTime();
		else
			newvalue = 0;
		end
	
	--- si enchant, prend le temps restant
	elseif (PowaSet[numi].bufftype == 5) then
		local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();
		if (mainHandExpiration and Powa_Frames[numi].buffindex == 1) then 
			newvalue = mainHandExpiration / 1000;
		elseif (offHandExpiration and Powa_Frames[numi].buffindex == 2) then
			newvalue = offHandExpiration / 1000;
		else 
			newvalue = 0; 
		end
	--- si un buff, prend la valeur restante
	elseif (PowaSet[numi].bufftype == 1) then
		if unitidentifikation == "party" then
			if numpm > 0 then
				for i=1, numpm do
					_, _, _, _, _, _, newvalue, isMine = UnitAura(unitidentifikation..i,Powa_Frames[numi].buffindex,"HELPFUL");
					if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
					if (bemine and isMine) or (not bemine) then
						if newvalue then newvalue = newvalue - GetTime() end
						if newvalue and newvalue > 0 then
							if lastvalue and lastvalue > 0 then
								if lastvalue < newvalue then
									newvalue = lastvalue;
								end
							end
						end
						lastvalue = newvalue
					end
				end
			end
		elseif unitidentifikation == "raid" then
			if numrm > 0 then
				for i=1, numrm do
					_, _, _, _, _, _, newvalue, isMine = UnitAura(unitidentifikation..i,Powa_Frames[numi].buffindex,"HELPFUL");
					if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
					if (bemine and isMine) or (not bemine) then
						if newvalue then newvalue = newvalue - GetTime() end
						if newvalue and newvalue > 0 then
							if lastvalue and lastvalue > 0 then
								if lastvalue < newvalue then
									newvalue = lastvalue;
								end
							end
						end
						lastvalue = newvalue
					end
				end
			end
		else
			name, rank, iconTexture, _, _, _, newvalue, isMine = UnitAura(unitidentifikation, Powa_Frames[numi].buffindex, "HELPFUL");
			if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
			if (bemine and isMine) or (not bemine) then
				if newvalue then newvalue = newvalue - GetTime() end
			end
		end
---		PowaDebug("bufftimeleft="..newvalue.." buffindex="..Powa_Frames[numi].buffindex);
	--- si un debuff, prend la valeur restante
	elseif (PowaSet[numi].bufftype == 2 or PowaSet[numi].bufftype == 3) then
		if unitidentifikation == "party" then
			if numpm > 0 then
				for i=1, numpm do
					_, _, _, _, _, _, newvalue, isMine = UnitAura(unitidentifikation..i, Powa_Frames[numi].buffindex, "HARMFUL");
					if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
					if (bemine and isMine) or (not bemine) then
						if newvalue then newvalue = newvalue - GetTime() end
						if newvalue and newvalue > 0 then
							if lastvalue and lastvalue > 0 then
								if lastvalue < newvalue then
									newvalue = lastvalue;
								end
							end
						end
						lastvalue = newvalue
					end
				end
			end
		elseif unitidentifikation == "raid" then
			if numrm > 0 then
				for i=1, numrm do
					_, _, _, _, _, _, newvalue, isMine = UnitAura(unitidentifikation..i, Powa_Frames[numi].buffindex, "HARMFUL");
					if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
					if (bemine and isMine) or (not bemine) then
						if newvalue then newvalue = newvalue - GetTime() end
						if newvalue and newvalue > 0 then
							if lastvalue and lastvalue > 0 then
								if lastvalue < newvalue then
									newvalue = lastvalue;
								end
							end
						end
						lastvalue = newvalue
					end
				end
			end
		else
			name, rank, iconTexture, _, _, _, newvalue, isMine = UnitAura(unitidentifikation, Powa_Frames[numi].buffindex, "HARMFUL");
			if isULDUAR then isMine = UnitExists(isMine) and UnitIsUnit("player", isMine) end
			if (bemine and isMine) or (not bemine) then
				if newvalue then newvalue = newvalue - GetTime() end
			end
		end
---		PowaDebug("debufftimeleft="..newvalue.." buffindex="..Powa_Frames[numi].buffindex);
	--- sinon, ne met rien
	elseif (PowaSet[numi].bufftype == 7) then
		local cdstart, cdduration, enable = GetActionCooldown(PowaSet[numi].opt1);
		--- cdstart = starttime of the CD, cdduration = duration of the cd
		--- ok when cdstart + cdduration = endtime
		if (cdstart > 0 and enable > 0) then
			local endtime = cdstart + cdduration;
			--- timeleft = endtime - actualtime
		  newvalue = (endtime - GetTime());
		else
			newvalue = 0;
	  end
		---PowaDebug("CDtimeleft="..newvalue);
	--- si duree buff/debuff cible, prend la valeur de la duree
	else
		newvalue = 0;
	end

	--- Create timer if not Created already
	Powa_CreateTimer(numi);
	--- init
	if (Powa_Timer[ntimer].value == nil) then Powa_Timer[ntimer].value = 0; end
	if (Powa_Timer2[ntimer].value == nil) then Powa_Timer2[ntimer].value = 0; end

	if (newvalue and newvalue > 0) then --- ok on a un timer a afficher...
		if ((Powa_Timer[ntimer].value > 0) and (newvalue > Powa_Timer[ntimer].value)) then
			--- y'a deja un timer dont le nombre est plus petit, verifie le second
			if (PowaTimer[ntimer].dual == true and PowaTimer[ntimer].cents == true) then
				if ((Powa_Timer2[ntimer].value > 0) and (newvalue > Powa_Timer2[ntimer].value)) then
					--- le second est pris, tant pis...
					return;
				else
					Powa_Timer2[ntimer].num = numi;          --- lien vers l'effet
					Powa_Timer2[ntimer].value = newvalue; --- retiens la valeur
				end
			else
				return;
			end
		else
			Powa_Timer2[ntimer].num = Powa_Timer[ntimer].num;
			Powa_Timer2[ntimer].value = Powa_Timer[ntimer].value;
			Powa_Timer[ntimer].num = numi;       --- lien vers l'effet
			Powa_Timer[ntimer].value = newvalue; --- retiens la valeur
		end
	end
end

function Powa_ResetTimers()
	local deci, uni, newvalue, timedEffect;

---	for i = 1, 5 do
	for k,v in pairs(Powa_Timer) do
		timedEffect = Powa_Timer[k].num;
		if (timedEffect and timedEffect > 0) then
		--- le timer en cours doit etre affiche	
			if ((Powa_Frames[timedEffect]:IsVisible()) or ((PowaSet[timedEffect].bufftype == 7) and not (AuraHide == true)))then --- l'effet est visible, affiche
				---PowaDebug("bufftype == "..PowaSet[timedEffect].bufftype);
				--- timer 1, le gros (secondes)
				if (PowaSet[k].texmode == 1) then
					Powa_timertex[k]:SetBlendMode("ADD");
				else
					Powa_timertex[k]:SetBlendMode("DISABLE");
				end
				if Powa_textures[timedEffect]:GetObjectType() == "Texture" then
					Powa_timertex[k]:SetVertexColor(Powa_textures[timedEffect]:GetVertexColor());
				elseif Powa_textures[timedEffect]:GetObjectType() == "FontString" then
					Powa_timertex[k]:SetVertexColor(Powa_textures[timedEffect]:GetTextColor());
				end
				--- si le timer est > 60, le transforme en minutes
				newvalue = Powa_Timer[k].value;
				if (newvalue > 60.00) then 
					newvalue = newvalue / 60; 
				end
				newvalue = math.min (99.00, newvalue);
		
				deci = math.floor(newvalue / 10);
				uni  = math.floor(newvalue - (deci*10));
				Powa_timertex[k]:SetTexCoord(Tstep * uni, Tstep * (uni+1), Tstep * deci, Tstep * (deci+1));
				Powa_Timer[k]:Show();
				--- timer 2, le petit (centieme de secondes)
				--- mode 2eme timer...
				if (PowaTimer[k].dual == true and PowaTimer[k].cents == true and Powa_Timer2[k].value > 0) then
					if (PowaSet[k].texmode == 1) then
						Powa_timertex2[k]:SetBlendMode("ADD");
					else
						Powa_timertex2[k]:SetBlendMode("DISABLE");
					end
					if Powa_textures[Powa_Timer2[k].num]:GetObjectType() == "Texture" then
						Powa_timertex2[k]:SetVertexColor(Powa_textures[Powa_Timer2[k].num]:GetVertexColor());
					elseif Powa_textures[Powa_Timer2[k].num]:GetObjectType() == "FontString" then
						Powa_timertex2[k]:SetVertexColor(Powa_textures[Powa_Timer2[k].num]:GetTextColor());
					end
					newvalue = Powa_Timer2[k].value;
					if (newvalue > 60.00) then 
						newvalue = newvalue / 60; 
					end
					newvalue = math.min (99.00, newvalue);
			
					deci = math.floor(newvalue / 10);
					uni  = math.floor(newvalue - (deci*10));
					Powa_timertex2[k]:SetTexCoord(Tstep * uni, Tstep * (uni+1), Tstep * deci, Tstep * (deci+1));
					Powa_Timer2[k]:Show();
				elseif (PowaTimer[k].cents == true) then --- mode normal (centiemes)
					if (PowaSet[k].texmode == 1) then
						Powa_timertex2[k]:SetBlendMode("ADD");
					else
						Powa_timertex2[k]:SetBlendMode("DISABLE");
					end
					if Powa_textures[timedEffect]:GetObjectType() == "Texture" then
						Powa_timertex2[k]:SetVertexColor(Powa_textures[timedEffect]:GetVertexColor());
					elseif Powa_textures[timedEffect]:GetObjectType() == "FontString" then
						Powa_timertex2[k]:SetVertexColor(Powa_textures[timedEffect]:GetTextColor());
					end

					newvalue = Powa_Timer[k].value;
					if (newvalue > 60.00) then 
						newvalue = math.fmod(newvalue,60); 
					else
						newvalue = (newvalue - math.floor(newvalue)) * 100;
					end
					deci = math.floor(newvalue / 10);
					uni  = math.floor(newvalue - (deci*10));
					Powa_timertex2[k]:SetTexCoord(Tstep * uni, Tstep * (uni+1), Tstep * deci, Tstep * (deci+1));
					Powa_Timer2[k]:Show();
				else
					Powa_Timer2[k]:Hide();
				end
			else			
				Powa_Timer[k]:Hide();  --- cache les timer
				Powa_Timer2[k]:Hide(); --- cache les timer
			end	
		else
			Powa_Timer[k]:Hide();  --- cache les timer
			Powa_Timer2[k]:Hide(); --- cache les timer		
		end

		--- reset
		Powa_Timer[k].num = 0;
		Powa_Timer[k].value = 0;
		Powa_Timer2[k].num = 0;
		Powa_Timer2[k].value = 0;
	end --- end for
end

function Powa_StaticPopups()
	
	StaticPopupDialogs["POWERAURAS_IMPORT_AURA"] = {
		text = PowaText.aideImport,
		button1 = ACCEPT,
		button2 = CANCEL,
		hasEditBox = 1,
		maxLetters = 2000,
		hasWideEditBox = 1,
		OnAccept = function(self)
			local aurastring = self.wideEditBox:GetText();
			if aurastring and aurastring ~= "" then
				Powa_ImportAura(CurrentAura, aurastring);
			end
		end,
		OnShow = function(self)
			self.wideEditBox:SetFocus();
		end,
		OnHide = function(self)
			if ( ChatFrameEditBox:IsShown() ) then
				ChatFrameEditBox:SetFocus();
			end
			self.wideEditBox:SetText("");
			Powa_DisplayAura(CurrentAura);
			Powa_UpdateMainOption();
		end,
		EditBoxOnEnterPressed = function(self)
			local parent = self:GetParent();
			local aurastring = parent.wideEditBox:GetText();
			if aurastring and aurastring ~= "" then
				Powa_ImportAura(CurrentAura, aurastring);
			end
			parent:Hide();
		end,
		EditBoxOnEscapePressed = function(self)
			self:GetParent():Hide();
		end,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		hideOnEscape = 1
	};	
	
	StaticPopupDialogs["POWERAURAS_EXPORT_AURA"] = {
		text = PowaText.aideExport,
		button1 = OKAY,
		button2 = EXIT,
		hasEditBox = 1,
		maxLetters = 2000,
		hasWideEditBox = 1,
		OnShow = function(self)
			self.wideEditBox:SetText(Powa_CreateAuraString(CurrentAura));
			self.wideEditBox:SetFocus();
			self.wideEditBox:HighlightText();
		end,
		OnHide = function(self)
			if ( ChatFrameEditBox:IsShown() ) then
				ChatFrameEditBox:SetFocus();
			end
			self.wideEditBox:SetText("");
		end,
		EditBoxOnEnterPressed = function(self)
			self:GetParent():Hide();
		end,
		EditBoxOnEscapePressed = function(self)
			self:GetParent():Hide();
		end,
		timeout = 0,
		exclusive = 1,
		whileDead = 1,
		hideOnEscape = 1
	};
	
end

--- ------------------------------------------------------------------------------------ GESTION DES OPTIONS
function Powa_UpdateAura() --- met a jour l'effet apres modification d'options

	if (PowaEnabled == 0) then return; end   --- desactived

	Powa_CreateFrames(CurrentAura);

	Powa_FramesVisibleTime[CurrentAura] = 0;
	Powa_FramesVisibleTime[SecondeAura] = 0;

	if (Powa_Frames[CurrentAura]:IsVisible()) then --- sinon on affiche seulement si deja visible
		Powa_DisplayAura(CurrentAura);
	end
end

function Powa_OptionTest() --- teste ou masque l'effet choisi

	Powa_CreateFrames(CurrentAura);

	if (PowaSet[CurrentAura] == nil or PowaSet[CurrentAura].buffname == "" or PowaSet[CurrentAura].buffname == " ") then
		return;
	end

	if (Powa_Frames[CurrentAura]:IsVisible()) then --- deja visible, on la cache
		Powa_FramesVisibleTime[CurrentAura] = 0;
		Powa_FramesVisibleTime[SecondeAura] = 0;
	else                                           --- pas visible alors on affiche
		Powa_DisplayAura(CurrentAura);
	end
end

function Powa_OptionHideAll(now) --- cache tous les effets
	--- cache tous les effets en test
	for i = 0, MaxAuras do
		Powa_FramesVisibleTime[i] = 0;
	end
	--- force Hide on mod shutdown
	if now then
		for i = 0, MaxAuras do
			if Powa_Frames[i] then
				Powa_Frames[i]:Hide();
			end
			if Powa_Timer[i] then
				Powa_Timer[i]:Hide();
			end
			if Powa_Timer2[i] then
				Powa_Timer2[i]:Hide();
			end
		end
	end
end
